package ambit.data.qmrf;


import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.apache.poi.hssf.usermodel.HSSFCellStyle;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.usermodel.HSSFPalette;
import org.apache.poi.hssf.usermodel.HSSFRichTextString;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.hssf.util.Region;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;



public class Qmrf_Xml_Excel {
	protected static Pattern CRLF = Pattern.compile("(<html>|</html>|<head>|</head>|<body>|</body>|<b>|</b>|<i>|</i>)");
	protected static Pattern ptag = Pattern.compile("(<p>)");
	
	//public void xml2excel(InputStream  xml, OutputStream excel) {
	public void xml2excel(InputSource source, OutputStream excel) {		
		try{
			
			HSSFWorkbook wb = new HSSFWorkbook();
			HSSFSheet sheet1 = wb.createSheet("README");
		    HSSFSheet sheet2 = wb.createSheet("QRF");
		    String chapter = "";
			String name = "";
			String value = "";
			String sub_chapter_number = "";
			String sub_chapter_name = "";
			String sub_chapter_text= "";
		    
		    
		   
//			bold text
		    HSSFFont font = wb.createFont();
		    font.setFontHeightInPoints((short)10);
		    font.setFontName("Arial");
		    font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
		    
		    //italic text
		    HSSFFont font1 = wb.createFont();
		    font1.setFontName("Arial");
		    font1.setFontHeightInPoints((short)9);	    
		    font1.setItalic(true);	 
		    
		    //dynamic text
		    HSSFFont dynamic_text = wb.createFont();
		    dynamic_text.setFontName("Arial");
		    dynamic_text.setFontHeightInPoints((short)9);
		    
		    //dynamic text
		    HSSFFont help_text = wb.createFont();
		    help_text.setFontName("Arial");
		    help_text.setFontHeightInPoints((short)8);	    
		    
		    
		    //header row
		    HSSFCellStyle cellStyle = wb.createCellStyle();
	        cellStyle.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle.setFillForegroundColor(HSSFColor.GREY_40_PERCENT.index);       
	        cellStyle.setFillPattern(HSSFCellStyle.SOLID_FOREGROUND);
	        cellStyle.setWrapText( true );
	        cellStyle.setFont(font);
	        cellStyle.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        
	        
	        //yellow cells chapter 
	        HSSFCellStyle cellStyle_chapter = wb.createCellStyle();
	        cellStyle_chapter.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_chapter.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle_chapter.setFillPattern((short)1);        
	        cellStyle_chapter.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        cellStyle_chapter.setBorderBottom(HSSFCellStyle.BORDER_THIN);
	        cellStyle_chapter.setBorderRight(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_chapter.setWrapText( true );
	        cellStyle_chapter.setFont(font);
	        cellStyle_chapter.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        HSSFPalette palette = wb.getCustomPalette();        
	        palette.setColorAtIndex(HSSFColor.YELLOW.index,
	        				
	                (byte) 255,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 153     //RGB blue
	        );
	        
	        
	        
	        
	        //yellow cells subchapter
	        HSSFCellStyle cellStyle1 = wb.createCellStyle();
	        cellStyle1.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle1.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle1.setFillPattern((short)1);
	        cellStyle1.setBorderTop(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle1.setBorderBottom(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle1.setBorderRight(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle1.setBorderLeft(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle1.setWrapText( true );
	        cellStyle1.setFont(font);
	        cellStyle1.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        palette = wb.getCustomPalette();        
	        palette.setColorAtIndex(HSSFColor.YELLOW.index,
	        				
	                (byte) 255,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 153     //RGB blue
	        );
	        //yellow cells subchapter first
	        HSSFCellStyle cellStyle_yellow_subchapter_first = wb.createCellStyle();
	        cellStyle_yellow_subchapter_first.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_yellow_subchapter_first.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle_yellow_subchapter_first.setFillPattern((short)1);
	        cellStyle_yellow_subchapter_first.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        cellStyle_yellow_subchapter_first.setBorderBottom(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_yellow_subchapter_first.setBorderRight(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_yellow_subchapter_first.setBorderLeft(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_yellow_subchapter_first.setWrapText( true );
	        cellStyle_yellow_subchapter_first.setFont(font);
	        cellStyle_yellow_subchapter_first.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        palette = wb.getCustomPalette();        
	        palette.setColorAtIndex(HSSFColor.YELLOW.index,
	        				
	                (byte) 255,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 153     //RGB blue
	        );
	        
	        //green cells chapter 
	        HSSFCellStyle green_cellStyle_chapter = wb.createCellStyle();
	        green_cellStyle_chapter.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        green_cellStyle_chapter.setFillForegroundColor(HSSFColor.GREEN.index);       
	        green_cellStyle_chapter.setFillPattern((short)1);
	        green_cellStyle_chapter.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        green_cellStyle_chapter.setBorderBottom(HSSFCellStyle.BORDER_THIN);
	        green_cellStyle_chapter.setBorderRight(HSSFCellStyle.BORDER_DOTTED);       
	        green_cellStyle_chapter.setWrapText( true );
	        green_cellStyle_chapter.setFont(font);
	        green_cellStyle_chapter.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        palette = wb.getCustomPalette();        
	        palette.setColorAtIndex(HSSFColor.GREEN.index,
	        				
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        
	        //green cells subchapter
	        HSSFCellStyle green_cellStyle_subchapter = wb.createCellStyle();
	        green_cellStyle_subchapter.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        green_cellStyle_subchapter.setFillForegroundColor(HSSFColor.GREEN.index);       
	        green_cellStyle_subchapter.setFillPattern((short)1);
	        green_cellStyle_subchapter.setBorderTop(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter.setBorderBottom(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter.setBorderRight(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter.setBorderLeft(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter.setWrapText( true );
	        green_cellStyle_subchapter.setFont(font);
	        green_cellStyle_subchapter.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        palette = wb.getCustomPalette();        
	        palette.setColorAtIndex(HSSFColor.GREEN.index,
	        				
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        //green cells subchapter first row
	        HSSFCellStyle green_cellStyle_subchapter_first = wb.createCellStyle();
	        green_cellStyle_subchapter_first.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        green_cellStyle_subchapter_first.setFillForegroundColor(HSSFColor.GREEN.index);       
	        green_cellStyle_subchapter_first.setFillPattern((short)1);
	        green_cellStyle_subchapter_first.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        green_cellStyle_subchapter_first.setBorderBottom(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter_first.setBorderRight(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter_first.setBorderLeft(HSSFCellStyle.BORDER_DOTTED);
	        green_cellStyle_subchapter_first.setWrapText( true );
	        green_cellStyle_subchapter_first.setFont(font);
	        green_cellStyle_subchapter_first.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        palette = wb.getCustomPalette();        
	        palette.setColorAtIndex(HSSFColor.GREEN.index,
	        				
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        
	        
	        //yellow cells  dynamic text
	        HSSFCellStyle cellStyle_dynamic_text = wb.createCellStyle();
	        cellStyle_dynamic_text.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_dynamic_text.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle_dynamic_text.setFillPattern((short)1);
	        cellStyle_dynamic_text.setBorderTop(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_dynamic_text.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text.setWrapText( true );
	        cellStyle_dynamic_text.setFont(dynamic_text);
	        cellStyle_dynamic_text.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        //yellow cells  dynamic text first
	        HSSFCellStyle cellStyle_dynamic_text_first = wb.createCellStyle();
	        cellStyle_dynamic_text_first.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_dynamic_text_first.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle_dynamic_text_first.setFillPattern((short)1);
	        cellStyle_dynamic_text_first.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_first.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_first.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_first.setWrapText( true );
	        cellStyle_dynamic_text_first.setFont(dynamic_text);
	        cellStyle_dynamic_text_first.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        //green cells  dynamic text
	        HSSFCellStyle cellStyle_dynamic_text_green = wb.createCellStyle();
	        cellStyle_dynamic_text_green.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_dynamic_text_green.setFillForegroundColor(HSSFColor.ROSE.index); 
	        palette.setColorAtIndex(HSSFColor.ROSE.index,
					
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        cellStyle_dynamic_text_green.setFillPattern((short)1);
	        cellStyle_dynamic_text_green.setBorderTop(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_dynamic_text_green.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_green.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_green.setWrapText( true );
	        cellStyle_dynamic_text_green.setFont(dynamic_text);
	        cellStyle_dynamic_text_green.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        //green cells  dynamic text
	        HSSFCellStyle cellStyle_dynamic_text_green_first = wb.createCellStyle();
	        cellStyle_dynamic_text_green_first.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_dynamic_text_green_first.setFillForegroundColor(HSSFColor.ROSE.index); 
	        palette.setColorAtIndex(HSSFColor.ROSE.index,
					
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        cellStyle_dynamic_text_green_first.setFillPattern((short)1);
	        cellStyle_dynamic_text_green_first.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_green_first.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_green_first.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_dynamic_text_green_first.setWrapText( true );
	        cellStyle_dynamic_text_green_first.setFont(dynamic_text);
	        cellStyle_dynamic_text_green_first.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        
	        //yellow cells  help text
	        HSSFCellStyle cellStyle_help_text = wb.createCellStyle();
	        cellStyle_help_text.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_help_text.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle_help_text.setFillPattern((short)1);
	        cellStyle_help_text.setBorderTop(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_help_text.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text.setWrapText( true );
	        cellStyle_help_text.setFont(help_text);
	        cellStyle_help_text.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        //yellow cells  help text first cell
	        HSSFCellStyle cellStyle_yellow_help_text_first = wb.createCellStyle();
	        cellStyle_yellow_help_text_first.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_yellow_help_text_first.setFillForegroundColor(HSSFColor.YELLOW.index);       
	        cellStyle_yellow_help_text_first.setFillPattern((short)1);
	        cellStyle_yellow_help_text_first.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        cellStyle_yellow_help_text_first.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_yellow_help_text_first.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_yellow_help_text_first.setWrapText( true );
	        cellStyle_yellow_help_text_first.setFont(help_text);
	        cellStyle_yellow_help_text_first.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        //green cells  help text
	        HSSFCellStyle cellStyle_help_text_green = wb.createCellStyle();
	        cellStyle_help_text_green.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_help_text_green.setFillForegroundColor(HSSFColor.ROSE.index); 
	        palette.setColorAtIndex(HSSFColor.ROSE.index,
					
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        cellStyle_help_text_green.setFillPattern((short)1);
	        cellStyle_help_text_green.setBorderTop(HSSFCellStyle.BORDER_DOTTED);
	        cellStyle_help_text_green.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text_green.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text_green.setWrapText( true );
	        cellStyle_help_text_green.setFont(help_text);
	        cellStyle_help_text_green.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        //green cells  help text first cell
	        HSSFCellStyle cellStyle_help_text_green_first = wb.createCellStyle();
	        cellStyle_help_text_green_first.setAlignment(HSSFCellStyle.ALIGN_LEFT);      
	        cellStyle_help_text_green_first.setFillForegroundColor(HSSFColor.ROSE.index); 
	        palette.setColorAtIndex(HSSFColor.ROSE.index,
					
	                (byte) 204,  //RGB red (0-255)
	                (byte) 255,    //RGB green
	                (byte) 204     //RGB blue
	        );
	        cellStyle_help_text_green_first.setFillPattern((short)1);
	        cellStyle_help_text_green_first.setBorderTop(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text_green_first.setBorderRight(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text_green_first.setBorderLeft(HSSFCellStyle.BORDER_THIN);
	        cellStyle_help_text_green_first.setWrapText( true );
	        cellStyle_help_text_green_first.setFont(help_text);
	        cellStyle_help_text_green_first.setVerticalAlignment(HSSFCellStyle.VERTICAL_TOP );
	        
	        
	        
	        
	        
	        
	        
	        
	        
	        
	        
	        
	       //row1
	        HSSFRow row = sheet2.createRow((short)0);
	        
		    row.createCell((short)0).setCellValue("QMRF CHPTER TITLES");
		    row.getCell((short)0).setCellStyle(cellStyle);
		    row.createCell((short)1).setCellValue("SECTION TITLES");
		    row.getCell((short)1).setCellStyle(cellStyle);
		    row.createCell((short)2).setCellValue("SUBSECTIONS TITLES");
		    row.getCell((short)2).setCellStyle(cellStyle);
		    row.createCell((short)3).setCellValue("Help on the content");
		    row.getCell((short)3).setCellStyle(cellStyle);
		   
		    
		    HSSFRichTextString bold_string = new HSSFRichTextString("MODEL DESCRIPTION \n (Fill in this column)");
		    bold_string.applyFont(0, 17,font); 
		    bold_string.applyFont(18,bold_string.length(),font1);

		    row.createCell((short)4).setCellValue(bold_string);
		    row.getCell((short)4).setCellStyle(cellStyle);
		    
			
 		    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();

			QMRFSchemaResolver resolver = new QMRFSchemaResolver("http://ambit.acad.bg/qmrf/qmrf.dtd",null);
			resolver.setIgnoreSystemID(true);
			docBuilder.setEntityResolver(resolver);

			org.w3c.dom.Document doc = docBuilder.parse(source);			
			
			
			//row2
		    HSSFRow row2 = sheet2.createRow((short)1);
		    chapter = findAttributeValue("QSAR_identifier","chapter", doc);
			name = findAttributeValue("QSAR_identifier","name", doc);
			value = chapter+". "+ name;	   
		    row2.createCell((short)0).setCellValue(value);	   
		    row2.getCell((short)0).setCellStyle(cellStyle_chapter);
		   
		    sheet2.addMergedRegion(new Region(1,(short)0,4,(short)0));
		  
		    
		    row2.createCell((short)1);
		    row2.getCell((short)1).setCellStyle(cellStyle_yellow_subchapter_first);
		    row2.createCell((short)2);
		    row2.getCell((short)2).setCellStyle(cellStyle_yellow_subchapter_first);
		    
		    row2.createCell((short)3);
		    row2.getCell((short)3).setCellStyle(cellStyle_yellow_help_text_first);
		    row2.createCell((short)4);
		    row2.getCell((short)4).setCellStyle(cellStyle_dynamic_text_first);
		    
		   
			
			
			
			
			//row3
		    sub_chapter_number = findAttributeValue("QSAR_title","chapter", doc);
			sub_chapter_name = findAttributeValue("QSAR_title","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			HSSFRow row3 = sheet2.createRow((short)2);
		    row3.createCell((short)1).setCellValue(value);
		    row3.getCell((short)1).setCellStyle(cellStyle1);
		    
		    row3.createCell((short)2);
		    row3.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("QSAR_title","help",doc);
		    row3.createCell((short)3).setCellValue(value);
		    row3.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    
		    value = findNodeValue("QSAR_title",doc);
		    row3.createCell((short)4).setCellValue(value);
		    row3.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    
		    //row4
		    HSSFRow row4 = sheet2.createRow((short)3);
		    sub_chapter_number = findAttributeValue("QSAR_models","chapter", doc);
			sub_chapter_name = findAttributeValue("QSAR_models","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
		    row4.createCell((short)1).setCellValue(value);
		    row4.getCell((short)1).setCellStyle(cellStyle1);
		    
		    row4.createCell((short)2);
		    row4.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("QSAR_models","help",doc);
		    row4.createCell((short)3).setCellValue(value);
		    row4.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    
		    value = findNodeValue("QSAR_models",doc);
		    row4.createCell((short)4).setCellValue(value);
		    row4.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    
		    //row5
		    HSSFRow row5 = sheet2.createRow((short)4);
		    sub_chapter_number = findAttributeValue("QSAR_software","chapter", doc);
			sub_chapter_name = findAttributeValue("QSAR_software","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
		    row5.createCell((short)1).setCellValue(value);
		    row5.getCell((short)1).setCellStyle(cellStyle1);
		   
		    row5.createCell((short)2);
		    row5.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("QSAR_software","help",doc);
		    row5.createCell((short)3).setCellValue(value);
		    row5.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    row5.createCell((short)4);
		    row5.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    
		    //row6
		    HSSFRow row6 = sheet2.createRow((short)5);
		    chapter = findAttributeValue("QSAR_General_information","chapter", doc);
			name = findAttributeValue("QSAR_General_information","name", doc);
			value = chapter+". "+ name;	
			
			
		    row6.createCell((short)0).setCellValue(value);
		    row6.getCell((short)0).setCellStyle(green_cellStyle_chapter);
		   
		    row6.createCell((short)1);
		    row6.getCell((short)1).setCellStyle(green_cellStyle_subchapter_first);
		    row6.createCell((short)2);
		    row6.getCell((short)2).setCellStyle(green_cellStyle_subchapter_first);
		    row6.createCell((short)3);
		    row6.getCell((short)3).setCellStyle(cellStyle_help_text_green_first);
		    row6.createCell((short)4);
		    row6.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green_first);
		    sheet2.addMergedRegion(new Region(5,(short)0,14,(short)0));
		    
		    
		    
		    
		    //row7
		    HSSFRow row7 = sheet2.createRow((short)6);	    
		    sub_chapter_number = findAttributeValue("qmrf_date","chapter", doc);
			sub_chapter_name = findAttributeValue("qmrf_date","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
		    row7.createCell((short)1).setCellValue(value);
		    row7.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
		    row7.createCell((short)2);
		    row7.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("qmrf_date","help",doc);
		    row7.createCell((short)3).setCellValue(value);
		    row7.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("qmrf_date",doc);
		    row7.createCell((short)4).setCellValue(value);
		    row7.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row8
		    HSSFRow row8 = sheet2.createRow((short)7);	    
		    sub_chapter_number = findAttributeValue("qmrf_authors","chapter", doc);
			sub_chapter_name = findAttributeValue("qmrf_authors","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
		    row8.createCell((short)1).setCellValue(value);
		    row8.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
		    row8.createCell((short)2);
		    row8.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("qmrf_authors","help",doc);
		    row8.createCell((short)3).setCellValue(value);
		    row8.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = "";
		    ArrayList qmrf_authors_list = findNodeIDRef("qmrf_authors","author_ref", "author", doc);
		    for (Iterator it = qmrf_authors_list.iterator(); it.hasNext(); ) {
		    	   Node qmrf_authors = (Node)it.next();
		    	   if(findAttributeValue("name",qmrf_authors).trim().length() > 0 ){
		    	   value += findAttributeValue("name",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("affiliation",qmrf_authors).trim().length() > 0 ){
		   	       value += findAttributeValue("affiliation",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("contact",qmrf_authors).trim().length() > 0 ){
		 	   	      
		   	       value += findAttributeValue("contact",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("email",qmrf_authors).trim().length() > 0 ){
			 	   	   
		   	       value += findAttributeValue("email",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("url",qmrf_authors).trim().length() > 0 ){
				 	   
		   	       value += findAttributeValue("url",qmrf_authors);
		   	       value += "\n";
		    	   }
		    }
		   
		    //value = findNodeValue("qmrf_authors",doc);	      
		    row8.createCell((short)4).setCellValue(value);	    	
		    row8.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row9
		    HSSFRow row9 = sheet2.createRow((short)8);	    
		    sub_chapter_number = findAttributeValue("qmrf_date_revision","chapter", doc);
			sub_chapter_name = findAttributeValue("qmrf_date_revision","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row9.createCell((short)1).setCellValue(value);
			row9.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row9.createCell((short)2);
			row9.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("qmrf_date_revision","help",doc);
		    row9.createCell((short)3).setCellValue(value);
		    row9.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("qmrf_date_revision",doc);	      
		    row9.createCell((short)4).setCellValue(value);	    	
		    row9.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row10
		    HSSFRow row10 = sheet2.createRow((short)9);	    
		    sub_chapter_number = findAttributeValue("qmrf_revision","chapter", doc);
			sub_chapter_name = findAttributeValue("qmrf_revision","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row10.createCell((short)1).setCellValue(value);
			row10.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row10.createCell((short)2);
			row10.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("qmrf_revision","help",doc);
		    row10.createCell((short)3).setCellValue(value);
		    row10.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("qmrf_revision",doc);	      
		    row10.createCell((short)4).setCellValue(value);	    	
		    row10.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row11
		    HSSFRow row11 = sheet2.createRow((short)10);	    
		    sub_chapter_number = findAttributeValue("model_authors","chapter", doc);
			sub_chapter_name = findAttributeValue("model_authors","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row11.createCell((short)1).setCellValue(value);
			row11.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row11.createCell((short)2);
			row11.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("model_authors","help",doc);
		    row11.createCell((short)3).setCellValue(value);
		    row11.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    //value = findNodeValue("model_authors",doc);
		    value = "";
		    ArrayList model_authors_list = findNodeIDRef("model_authors","author_ref", "author", doc);
		    for (Iterator it = model_authors_list.iterator(); it.hasNext(); ) {
		    	   Node qmrf_authors = (Node)it.next();
		    	   if(findAttributeValue("name",qmrf_authors).trim().length() > 0 ){
		    	   value += findAttributeValue("name",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("affiliation",qmrf_authors).trim().length() > 0 ){
		   	       value += findAttributeValue("affiliation",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("contact",qmrf_authors).trim().length() > 0 ){
		 	   	      
		   	       value += findAttributeValue("contact",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("email",qmrf_authors).trim().length() > 0 ){
			 	   	   
		   	       value += findAttributeValue("email",qmrf_authors);
		   	       value += "\n";
		    	   }
		    	   if(findAttributeValue("url",qmrf_authors).trim().length() > 0 ){
				 	   
		   	       value += findAttributeValue("url",qmrf_authors);
		   	       value += "\n";
		    	   }
		    }
		    row11.createCell((short)4).setCellValue(value);	    	
		    row11.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row12
		    HSSFRow row12 = sheet2.createRow((short)11);	    
		    sub_chapter_number = findAttributeValue("model_date","chapter", doc);
			sub_chapter_name = findAttributeValue("model_date","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row12.createCell((short)1).setCellValue(value);
			row12.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row12.createCell((short)2);
			row12.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("model_date","help",doc);
		    row12.createCell((short)3).setCellValue(value);
		    row12.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("model_date",doc);	      
		    row12.createCell((short)4).setCellValue(value);	    	
		    row12.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row13
		    HSSFRow row13 = sheet2.createRow((short)12);	    
		    sub_chapter_number = findAttributeValue("references","chapter", doc);
			sub_chapter_name = findAttributeValue("references","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row13.createCell((short)1).setCellValue(value);
			row13.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row13.createCell((short)2);
			row13.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("references","help",doc);
		    row13.createCell((short)3).setCellValue(value);
		    row13.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = "";
		    String prefix = "";
		    ArrayList publication_list = findNodeIDRef("references","publication_ref", "publication", doc);
	        ArrayList bold_array = new ArrayList();
		    String pub_string  = null;
	        HSSFRichTextString bold_string_pub = null;       
		    int num = 1;
		    
		    Qmrf_Xml_Excel.BoldProperty bp =null;
		    
		    for (Iterator it = publication_list.iterator(); it.hasNext(); ) {
		    	   Node publication = (Node)it.next();
		    	   
		    	   
		    	   if(findAttributeValue("title",publication).trim().length() > 0 ){
		    	   prefix = "["+num+"]";
		    	   pub_string = prefix +  findAttributeValue("title",publication);
		    	   //bold_string_pub = new HSSFRichTextString(pub_string);
		    	   //bold_string_pub.applyFont(0, prefix.length(),font); 
		    	   bp = new Qmrf_Xml_Excel().new BoldProperty();
		    	   bp.StartValue = value.length();
		    	   bp.EndValue = bp.StartValue + prefix.length();
		    	   bold_array.add(bp);
		    	   value += pub_string;
		   	       value += "\n";
		    	   }
		    	   num++;
		    	   
		    }
		    
		    
		   // value = findNodeValue("references",doc);
		    bold_string_pub = new HSSFRichTextString(value);
		    for (Iterator it = bold_array.iterator(); it.hasNext(); ) {
		    	   Qmrf_Xml_Excel.BoldProperty bold_border = (Qmrf_Xml_Excel.BoldProperty)it.next();
		    	   bold_string_pub.applyFont(bold_border.StartValue, bold_border.EndValue,font);
		    }
		    //row13.createCell((short)4).setCellValue(value);	
	 	    row13.createCell((short)4).setCellValue(bold_string_pub);
		    row13.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row14
		    HSSFRow row14 = sheet2.createRow((short)13);	    
		    sub_chapter_number = findAttributeValue("info_availability","chapter", doc);
			sub_chapter_name = findAttributeValue("info_availability","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row14.createCell((short)1).setCellValue(value);
			row14.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row14.createCell((short)2);
			row14.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("info_availability","help",doc);
		    row14.createCell((short)3).setCellValue(value);
		    row14.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("info_availability",doc);	      
		    row14.createCell((short)4).setCellValue(value);	    	
		    row14.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row15
		    HSSFRow row15 = sheet2.createRow((short)14);	    
		    sub_chapter_number = findAttributeValue("related_models","chapter", doc);
			sub_chapter_name = findAttributeValue("related_models","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row15.createCell((short)1).setCellValue(value);
			row15.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row15.createCell((short)2);
			row15.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("related_models","help",doc);
		    row15.createCell((short)3).setCellValue(value);
		    row15.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("related_models",doc);	      
		    row15.createCell((short)4).setCellValue(value);	    	
		    row15.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row16
		    HSSFRow row16 = sheet2.createRow((short)15);
		    chapter = findAttributeValue("QSAR_Endpoint","chapter", doc);
			name = findAttributeValue("QSAR_Endpoint","name", doc);
			value = chapter+". "+ name;	   
		    row16.createCell((short)0).setCellValue(value);	   
		    row16.getCell((short)0).setCellStyle(cellStyle_chapter);
		   
		    sheet2.addMergedRegion(new Region(15,(short)0,22,(short)0));
		    
		    
		    row16.createCell((short)1);
		    row16.getCell((short)1).setCellStyle(cellStyle_yellow_subchapter_first);
		    row16.createCell((short)2);
		    row16.getCell((short)2).setCellStyle(cellStyle_yellow_subchapter_first);
		    
		    row16.createCell((short)3);
		    row16.getCell((short)3).setCellStyle(cellStyle_yellow_help_text_first);
		    row16.createCell((short)4);
		    row16.getCell((short)4).setCellStyle(cellStyle_dynamic_text_first);
		    
		    //row17
		    HSSFRow row17 = sheet2.createRow((short)16);
		    sub_chapter_number = findAttributeValue("model_species","chapter", doc);
			sub_chapter_name = findAttributeValue("model_species","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row17.createCell((short)1).setCellValue(value);
			row17.getCell((short)1).setCellStyle(cellStyle1);
		   
			row17.createCell((short)2);
			row17.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("model_species","help",doc);
		    row17.createCell((short)3).setCellValue(value);
		    row17.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("model_species",doc);
		    row17.createCell((short)4).setCellValue(value);
		    row17.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row18
		    HSSFRow row18 = sheet2.createRow((short)17);
		    sub_chapter_number = findAttributeValue("model_endpoint","chapter", doc);
			sub_chapter_name = findAttributeValue("model_endpoint","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row18.createCell((short)1).setCellValue(value);
			row18.getCell((short)1).setCellStyle(cellStyle1);
		   
			row18.createCell((short)2);
			row18.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("model_endpoint","help",doc);
		    row18.createCell((short)3).setCellValue(value);
		    row18.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    //value = findNodeValue("model_endpoint",doc);
		    
		    value = "";
		    ArrayList model_endpoints_list = findNodeIDRef("model_endpoint","endpoint_ref", "endpoint", doc);
		    for (Iterator it = model_endpoints_list.iterator(); it.hasNext(); ) {
			   Node qmrf_endpoints = (Node)it.next();
			   if(findAttributeValue("name",qmrf_endpoints).trim().length() > 0 ){
			   value += findAttributeValue("name",qmrf_endpoints);
			       value += "\n";
			   }
		    	    	  
		    }	    
		    row18.createCell((short)4).setCellValue(value);
		    row18.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row19
		    HSSFRow row19 = sheet2.createRow((short)18);
		    sub_chapter_number = findAttributeValue("endpoint_comments","chapter", doc);
			sub_chapter_name = findAttributeValue("endpoint_comments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row19.createCell((short)1).setCellValue(value);
			row19.getCell((short)1).setCellStyle(cellStyle1);
		   
			row19.createCell((short)2);
			row19.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("endpoint_comments","help",doc);
		    row19.createCell((short)3).setCellValue(value);
		    row19.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("endpoint_comments",doc);
		    row19.createCell((short)4).setCellValue(value);
		    row19.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row20
		    HSSFRow row20 = sheet2.createRow((short)19);
		    sub_chapter_number = findAttributeValue("endpoint_units","chapter", doc);
			sub_chapter_name = findAttributeValue("endpoint_units","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row20.createCell((short)1).setCellValue(value);
			row20.getCell((short)1).setCellStyle(cellStyle1);
		   
			row20.createCell((short)2);
			row20.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("endpoint_units","help",doc);
		    row20.createCell((short)3).setCellValue(value);
		    row20.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("endpoint_units",doc);
		    row20.createCell((short)4).setCellValue(value);
		    row20.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row21
		    HSSFRow row21 = sheet2.createRow((short)20);
		    sub_chapter_number = findAttributeValue("endpoint_variable","chapter", doc);
			sub_chapter_name = findAttributeValue("endpoint_variable","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row21.createCell((short)1).setCellValue(value);
			row21.getCell((short)1).setCellStyle(cellStyle1);
		   
			row21.createCell((short)2);
			row21.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("endpoint_variable","help",doc);
		    row21.createCell((short)3).setCellValue(value);
		    row21.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("endpoint_variable",doc);
		    row21.createCell((short)4).setCellValue(value);
		    row21.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row22
		    HSSFRow row22 = sheet2.createRow((short)21);
		    sub_chapter_number = findAttributeValue("endpoint_protocol","chapter", doc);
			sub_chapter_name = findAttributeValue("endpoint_protocol","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row22.createCell((short)1).setCellValue(value);
			row22.getCell((short)1).setCellStyle(cellStyle1);
		   
			row22.createCell((short)2);
			row22.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("endpoint_protocol","help",doc);
		    row22.createCell((short)3).setCellValue(value);
		    row22.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("endpoint_protocol",doc);
		    row22.createCell((short)4).setCellValue(value);
		    row22.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row23
		    HSSFRow row23 = sheet2.createRow((short)22);
		    sub_chapter_number = findAttributeValue("endpoint_data_quality","chapter", doc);
			sub_chapter_name = findAttributeValue("endpoint_data_quality","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row23.createCell((short)1).setCellValue(value);
			row23.getCell((short)1).setCellStyle(cellStyle1);
		   
			row23.createCell((short)2);
			row23.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("endpoint_data_quality","help",doc);
		    row23.createCell((short)3).setCellValue(value);
		    row23.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("endpoint_data_quality",doc);
		    row23.createCell((short)4).setCellValue(value);
		    row23.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row24
		    HSSFRow row24 = sheet2.createRow((short)23);
		    chapter = findAttributeValue("QSAR_Algorithm","chapter", doc);
			name = findAttributeValue("QSAR_Algorithm","name", doc);
			value = chapter+". "+ name;	   
			  
		    
		    row24.createCell((short)0).setCellValue(value);
		    row24.getCell((short)0).setCellStyle(green_cellStyle_chapter);
		   
		    row24.createCell((short)1);
		    row24.getCell((short)1).setCellStyle(green_cellStyle_subchapter_first);
		    row24.createCell((short)2);
		    row24.getCell((short)2).setCellStyle(green_cellStyle_subchapter_first);
		    row24.createCell((short)3);
		    row24.getCell((short)3).setCellStyle(cellStyle_help_text_green_first);
		    row24.createCell((short)4);
		    row24.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green_first);
		    

		    sheet2.addMergedRegion(new Region(23,(short)0,31,(short)0));
		   
		    
		    //row25
		    HSSFRow row25 = sheet2.createRow((short)24);	    
		    sub_chapter_number = findAttributeValue("algorithm_type","chapter", doc);
			sub_chapter_name = findAttributeValue("algorithm_type","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row25.createCell((short)1).setCellValue(value);
			row25.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row25.createCell((short)2);
			row25.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("algorithm_type","help",doc);
		    row25.createCell((short)3).setCellValue(value);
		    row25.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("algorithm_type",doc);	      
		    row25.createCell((short)4).setCellValue(value);	    	
		    row25.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);	
		    
		    //row26
		    HSSFRow row26 = sheet2.createRow((short)25);	    
		    sub_chapter_number = findAttributeValue("algorithm_explicit","chapter", doc);
			sub_chapter_name = findAttributeValue("algorithm_explicit","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row26.createCell((short)1).setCellValue(value);
			row26.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row26.createCell((short)2);
			row26.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("algorithm_explicit","help",doc);
		    row26.createCell((short)3).setCellValue(value);
		    row26.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    //value = findNodeValue("algorithm_explicit",doc);
		    value = "";
		    ArrayList algorithm_list = findNodeIDRef("algorithm_explicit","algorithm_ref", "algorithm", doc);
		    for (Iterator it = algorithm_list.iterator(); it.hasNext(); ) {
			   Node qmrf_algorithms = (Node)it.next();
			   if(findAttributeValue("definition",qmrf_algorithms).trim().length() > 0 ){
			   value += findAttributeValue("definition",qmrf_algorithms);
			       value += "\n";
			   }
			   if(findAttributeValue("description",qmrf_algorithms).trim().length() > 0 ){
			       value += findAttributeValue("description",qmrf_algorithms);
			       value += "\n";
			   }
			   
		    }
		    row26.createCell((short)4).setCellValue(value);	    	
		    row26.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row27
		    HSSFRow row27 = sheet2.createRow((short)26);	    
		    sub_chapter_number = findAttributeValue("algorithm_comments","chapter", doc);
			sub_chapter_name = findAttributeValue("algorithm_comments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row27.createCell((short)1).setCellValue(value);
			row27.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row27.createCell((short)2);
			row27.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("algorithm_comments","help",doc);
		    row27.createCell((short)3).setCellValue(value);
		    row27.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("algorithm_comments",doc);	      
		    row27.createCell((short)4).setCellValue(value);	    	
		    row27.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row28
		    HSSFRow row28 = sheet2.createRow((short)27);	    
		    sub_chapter_number = findAttributeValue("algorithms_descriptors","chapter", doc);
			sub_chapter_name = findAttributeValue("algorithms_descriptors","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row28.createCell((short)1).setCellValue(value);
			row28.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row28.createCell((short)2);
			row28.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("algorithms_descriptors","help",doc);
		    row28.createCell((short)3).setCellValue(value);
		    row28.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    //value = findNodeValue("algorithms_descriptors",doc);
		    value = "";
		    ArrayList descriptor_list = findNodeIDRef("algorithms_descriptors","descriptor_ref", "descriptor", doc);
		    bold_array = new ArrayList();
		    for (Iterator it = descriptor_list.iterator(); it.hasNext(); ) {
			   Node qmrf_descriptors = (Node)it.next();
			   bp = new Qmrf_Xml_Excel().new BoldProperty();
	    	   bp.StartValue = value.length();
	    	   
			   if(findAttributeValue("name",qmrf_descriptors).trim().length() > 0 ){
			   value += findAttributeValue("name",qmrf_descriptors);
			       
			   }
			   if(findAttributeValue("units",qmrf_descriptors).trim().length() > 0 ){
				   value += ",";
				   value += findAttributeValue("units",qmrf_descriptors);
			      
			   }
			   bp.EndValue = bp.StartValue + (value.length() - bp.StartValue);
	    	   bold_array.add(bp);
			   if(findAttributeValue("description",qmrf_descriptors).trim().length() > 0 ){
				   value += " ";	
			       value += findAttributeValue("description",qmrf_descriptors);
			       value += "\n";
			   }		   
		    }
		    
		    //row28.createCell((short)4).setCellValue(value);
		    bold_string_pub = new HSSFRichTextString(value);
		    for (Iterator it = bold_array.iterator(); it.hasNext(); ) {
		    	   Qmrf_Xml_Excel.BoldProperty bold_border = (Qmrf_Xml_Excel.BoldProperty)it.next();
		    	   bold_string_pub.applyFont(bold_border.StartValue, bold_border.EndValue,font);
	        }
		    row28.createCell((short)4).setCellValue(bold_string_pub);
		    row28.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row29
		    HSSFRow row29= sheet2.createRow((short)28);	    
		    sub_chapter_number = findAttributeValue("descriptors_selection","chapter", doc);
			sub_chapter_name = findAttributeValue("descriptors_selection","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row29.createCell((short)1).setCellValue(value);
			row29.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row29.createCell((short)2);
			row29.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("descriptors_selection","help",doc);
		    row29.createCell((short)3).setCellValue(value);
		    row29.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("descriptors_selection",doc);	      
		    row29.createCell((short)4).setCellValue(value);	    	
		    row29.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row30
		    HSSFRow row30= sheet2.createRow((short)29);	    
		    sub_chapter_number = findAttributeValue("descriptors_generation","chapter", doc);
			sub_chapter_name = findAttributeValue("descriptors_generation","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row30.createCell((short)1).setCellValue(value);
			row30.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row30.createCell((short)2);
			row30.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("descriptors_generation","help",doc);
		    row30.createCell((short)3).setCellValue(value);
		    row30.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("descriptors_generation",doc);	      
		    row30.createCell((short)4).setCellValue(value);	    	
		    row30.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row31
		    HSSFRow row31= sheet2.createRow((short)30);	    
		    sub_chapter_number = findAttributeValue("descriptors_generation_software","chapter", doc);
			sub_chapter_name = findAttributeValue("descriptors_generation_software","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row31.createCell((short)1).setCellValue(value);
			row31.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row31.createCell((short)2);
			row31.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("descriptors_generation_software","help",doc);
		    row31.createCell((short)3).setCellValue(value);
		    row31.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    //value = findNodeValue("descriptors_generation_software",doc);	
		    value = "";
		    ArrayList software_list = findNodeIDRef("descriptors_generation_software","software_ref", "software", doc);
		    for (Iterator it = software_list.iterator(); it.hasNext(); ) {
			   Node qmrf_softwares = (Node)it.next();
			   if(findAttributeValue("name",qmrf_softwares).trim().length() > 0 ){
			   value += findAttributeValue("name",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("number",qmrf_softwares).trim().length() > 0 ){
			       value += findAttributeValue("number",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("description",qmrf_softwares).trim().length() > 0 ){

			       value += findAttributeValue("description",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("contact",qmrf_softwares).trim().length() > 0 ){

			       value += findAttributeValue("contact",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("url",qmrf_softwares).trim().length() > 0 ){

			       value += findAttributeValue("url",qmrf_softwares);
			       value += "\n";
			   }
		    }
		    row31.createCell((short)4).setCellValue(value);	    	
		    row31.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row32
		    HSSFRow row32= sheet2.createRow((short)31);	    
		    sub_chapter_number = findAttributeValue("descriptors_chemicals_ratio","chapter", doc);
			sub_chapter_name = findAttributeValue("descriptors_chemicals_ratio","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row32.createCell((short)1).setCellValue(value);
			row32.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row32.createCell((short)2);
			row32.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("descriptors_chemicals_ratio","help",doc);
		    row32.createCell((short)3).setCellValue(value);
		    row32.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    
		    value = findNodeValue("descriptors_chemicals_ratio",doc);	      
		    row32.createCell((short)4).setCellValue(value);	    	
		    row32.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row33
		    HSSFRow row33 = sheet2.createRow((short)32);
		    chapter = findAttributeValue("QSAR_Applicability_domain","chapter", doc);
			name = findAttributeValue("QSAR_Applicability_domain","name", doc);
			value = chapter+". "+ name;	   
			row33.createCell((short)0).setCellValue(value);	   
			row33.getCell((short)0).setCellStyle(cellStyle_chapter);
		   
		    sheet2.addMergedRegion(new Region(32,(short)0,36,(short)0));
		    
		  
		    
		    
		    row33.createCell((short)1);
		    row33.getCell((short)1).setCellStyle(cellStyle_yellow_subchapter_first);
		    row33.createCell((short)2);
		    row33.getCell((short)2).setCellStyle(cellStyle_yellow_subchapter_first);
		    
		    row33.createCell((short)3);
		    row33.getCell((short)3).setCellStyle(cellStyle_yellow_help_text_first);
		    row33.createCell((short)4);
		    row33.getCell((short)4).setCellStyle(cellStyle_dynamic_text_first);
		    
		    //row34
		    HSSFRow row34 = sheet2.createRow((short)33);
		    sub_chapter_number = findAttributeValue("app_domain_description","chapter", doc);
			sub_chapter_name = findAttributeValue("app_domain_description","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row34.createCell((short)1).setCellValue(value);
			row34.getCell((short)1).setCellStyle(cellStyle1);
		   
			row34.createCell((short)2);
			row34.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("app_domain_description","help",doc);
		    row34.createCell((short)3).setCellValue(value);
		    row34.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("app_domain_description",doc);
		    row34.createCell((short)4).setCellValue(value);
		    row34.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row35
		    HSSFRow row35 = sheet2.createRow((short)34);
		    sub_chapter_number = findAttributeValue("app_domain_method","chapter", doc);
			sub_chapter_name = findAttributeValue("app_domain_method","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row35.createCell((short)1).setCellValue(value);
			row35.getCell((short)1).setCellStyle(cellStyle1);
		   
			row35.createCell((short)2);
			row35.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("app_domain_method","help",doc);
		    row35.createCell((short)3).setCellValue(value);
		    row35.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("app_domain_method",doc);
		    row35.createCell((short)4).setCellValue(value);
		    row35.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row36
		    HSSFRow row36 = sheet2.createRow((short)35);
		    sub_chapter_number = findAttributeValue("app_domain_software","chapter", doc);
			sub_chapter_name = findAttributeValue("app_domain_software","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row36.createCell((short)1).setCellValue(value);
			row36.getCell((short)1).setCellStyle(cellStyle1);
		   
			row36.createCell((short)2);
			row36.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("app_domain_software","help",doc);
		    row36.createCell((short)3).setCellValue(value);
		    row36.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    //value = findNodeValue("app_domain_software",doc);
		    value = "";
		    software_list = findNodeIDRef("app_domain_software","software_ref", "software", doc);
		    for (Iterator it = software_list.iterator(); it.hasNext(); ) {
			   Node qmrf_softwares = (Node)it.next();
			   if(findAttributeValue("name",qmrf_softwares).trim().length() > 0 ){
			   value += findAttributeValue("name",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("number",qmrf_softwares).trim().length() > 0 ){
			       value += findAttributeValue("number",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("description",qmrf_softwares).trim().length() > 0 ){

			       value += findAttributeValue("description",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("contact",qmrf_softwares).trim().length() > 0 ){

			       value += findAttributeValue("contact",qmrf_softwares);
			       value += "\n";
			   }
			   if(findAttributeValue("url",qmrf_softwares).trim().length() > 0 ){

			       value += findAttributeValue("url",qmrf_softwares);
			       value += "\n";
			   }
		    }
		    row36.createCell((short)4).setCellValue(value);
		    row36.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row37
		    HSSFRow row37 = sheet2.createRow((short)36);
		    sub_chapter_number = findAttributeValue("applicability_limits","chapter", doc);
			sub_chapter_name = findAttributeValue("applicability_limits","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row37.createCell((short)1).setCellValue(value);
			row37.getCell((short)1).setCellStyle(cellStyle1);
		   
			row37.createCell((short)2);
			row37.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("applicability_limits","help",doc);
		    row37.createCell((short)3).setCellValue(value);
		    row37.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("applicability_limits",doc);
		    row37.createCell((short)4).setCellValue(value);
		    row37.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row38
		    HSSFRow row38 = sheet2.createRow((short)37);
		    chapter = findAttributeValue("QSAR_Robustness","chapter", doc);
			name = findAttributeValue("QSAR_Robustness","name", doc);
			value = chapter+". "+ name;	   


			row38.createCell((short)0).setCellValue(value);
			row38.getCell((short)0).setCellStyle(green_cellStyle_chapter);

			row38.createCell((short)1);
			row38.getCell((short)1).setCellStyle(green_cellStyle_subchapter_first);
			row38.createCell((short)2);
			row38.getCell((short)2).setCellStyle(green_cellStyle_subchapter_first);
			row38.createCell((short)3);
			row38.getCell((short)3).setCellStyle(cellStyle_help_text_green_first);
			row38.createCell((short)4);
			row38.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green_first);

			sheet2.addMergedRegion(new Region(37,(short)0,47,(short)0));
		    
		  
		    
		    //row39
		    HSSFRow row39= sheet2.createRow((short)38);	    
		    sub_chapter_number = findAttributeValue("training_set_availability","chapter", doc);
			sub_chapter_name = findAttributeValue("training_set_availability","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row39.createCell((short)1).setCellValue(value);
			row39.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row39.createCell((short)2);
			row39.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("training_set_availability","help",doc);
		    row39.createCell((short)3).setCellValue(value);
		    row39.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("training_set_availability",doc);	      
		    row39.createCell((short)4).setCellValue(value);	    	
		    row39.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row40
		    HSSFRow row40= sheet2.createRow((short)39);	    
		    sub_chapter_number = findAttributeValue("training_set_data","chapter", doc);
			sub_chapter_name = findAttributeValue("training_set_data","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row40.createCell((short)1).setCellValue(value);
			row40.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row40.createCell((short)2);
			row40.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("training_set_data","help",doc);
		    row40.createCell((short)3).setCellValue(value);
		    row40.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("training_set_data",doc);	      
		    row40.createCell((short)4).setCellValue(value);	    	
		    row40.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row41
		    HSSFRow row41= sheet2.createRow((short)40);	    
		    sub_chapter_number = findAttributeValue("training_set_descriptors","chapter", doc);
			sub_chapter_name = findAttributeValue("training_set_descriptors","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row41.createCell((short)1).setCellValue(value);
			row41.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row41.createCell((short)2);
			row41.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("training_set_descriptors","help",doc);
		    row41.createCell((short)3).setCellValue(value);
		    row41.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("training_set_descriptors",doc);	      
		    row41.createCell((short)4).setCellValue(value);	    	
		    row41.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row42
		    HSSFRow row42 = sheet2.createRow((short)41);	    
		    sub_chapter_number = findAttributeValue("dependent_var_availability","chapter", doc);
			sub_chapter_name = findAttributeValue("dependent_var_availability","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row42.createCell((short)1).setCellValue(value);
			row42.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row42.createCell((short)2);
			row42.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("dependent_var_availability","help",doc);
		    row42.createCell((short)3).setCellValue(value);
		    row42.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("dependent_var_availability",doc);	      
		    row42.createCell((short)4).setCellValue(value);	    	
		    row42.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row43
		    HSSFRow row43 = sheet2.createRow((short)42);	    
		    sub_chapter_number = findAttributeValue("other_info","chapter", doc);
			sub_chapter_name = findAttributeValue("other_info","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row43.createCell((short)1).setCellValue(value);
			row43.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row43.createCell((short)2);
			row43.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("other_info","help",doc);
		    row43.createCell((short)3).setCellValue(value);
		    row43.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("other_info",doc);	      
		    row43.createCell((short)4).setCellValue(value);	    	
		    row43.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row44
		    HSSFRow row44 = sheet2.createRow((short)43);	    
		    sub_chapter_number = findAttributeValue("preprocessing","chapter", doc);
			sub_chapter_name = findAttributeValue("preprocessing","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row44.createCell((short)1).setCellValue(value);
			row44.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row44.createCell((short)2);
			row44.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("preprocessing","help",doc);
		    row44.createCell((short)3).setCellValue(value);
		    row44.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("preprocessing",doc);	      
		    row44.createCell((short)4).setCellValue(value);	    	
		    row44.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row45
		    HSSFRow row45 = sheet2.createRow((short)44);	    
		    sub_chapter_number = findAttributeValue("goodness_of_fit","chapter", doc);
			sub_chapter_name = findAttributeValue("goodness_of_fit","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row45.createCell((short)1).setCellValue(value);
			row45.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row45.createCell((short)2);
			row45.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("goodness_of_fit","help",doc);
		    row45.createCell((short)3).setCellValue(value);
		    row45.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("goodness_of_fit",doc);	      
		    row45.createCell((short)4).setCellValue(value);	    	
		    row45.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row46
		    HSSFRow row46 = sheet2.createRow((short)45);	    
		    sub_chapter_number = findAttributeValue("loo","chapter", doc);
			sub_chapter_name = findAttributeValue("loo","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row46.createCell((short)1).setCellValue(value);
			row46.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row46.createCell((short)2);
			row46.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("loo","help",doc);
		    row46.createCell((short)3).setCellValue(value);
		    row46.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("loo",doc);	      
		    row46.createCell((short)4).setCellValue(value);	    	
		    row46.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row47
		    HSSFRow row47 = sheet2.createRow((short)46);	    
		    sub_chapter_number = findAttributeValue("lmo","chapter", doc);
			sub_chapter_name = findAttributeValue("lmo","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row47.createCell((short)1).setCellValue(value);
			row47.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row47.createCell((short)2);
			row47.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("lmo","help",doc);
		    row47.createCell((short)3).setCellValue(value);
		    row47.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("lmo",doc);	      
		    row47.createCell((short)4).setCellValue(value);	    	
		    row47.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row48
		    HSSFRow row48 = sheet2.createRow((short)47);	    
		    sub_chapter_number = findAttributeValue("yscrambling","chapter", doc);
			sub_chapter_name = findAttributeValue("yscrambling","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row48.createCell((short)1).setCellValue(value);
			row48.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row48.createCell((short)2);
			row48.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("yscrambling","help",doc);
		    row48.createCell((short)3).setCellValue(value);
		    row48.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("yscrambling",doc);	      
		    row48.createCell((short)4).setCellValue(value);	    	
		    row48.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row49
		    HSSFRow row49 = sheet2.createRow((short)48);
		    chapter = findAttributeValue("QSAR_Predictivity","chapter", doc);
			name = findAttributeValue("QSAR_Predictivity","name", doc);
			value = chapter+". "+ name;	   
			row49.createCell((short)0).setCellValue(value);	   
			row49.getCell((short)0).setCellStyle(cellStyle_chapter);
		   
		    sheet2.addMergedRegion(new Region(48,(short)0,57,(short)0));
		    
		    
		    
		  
		    
		    
		    row49.createCell((short)1);
		    row49.getCell((short)1).setCellStyle(cellStyle_yellow_subchapter_first);
		    row49.createCell((short)2);
		    row49.getCell((short)2).setCellStyle(cellStyle_yellow_subchapter_first);
		    
		    row49.createCell((short)3);
		    row49.getCell((short)3).setCellStyle(cellStyle_yellow_help_text_first);
		    row49.createCell((short)4);
		    row49.getCell((short)4).setCellStyle(cellStyle_dynamic_text_first);
		    
		    //row50
		    HSSFRow row50 = sheet2.createRow((short)49);
		    sub_chapter_number = findAttributeValue("validation_set_availability","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_set_availability","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row50.createCell((short)1).setCellValue(value);
			row50.getCell((short)1).setCellStyle(cellStyle1);
		   
			row50.createCell((short)2);
			row50.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_set_availability","help",doc);
		    row50.createCell((short)3).setCellValue(value);
		    row50.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_set_availability",doc);
		    row50.createCell((short)4).setCellValue(value);
		    row50.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row51
		    HSSFRow row51 = sheet2.createRow((short)50);
		    sub_chapter_number = findAttributeValue("validation_set_data","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_set_data","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row51.createCell((short)1).setCellValue(value);
			row51.getCell((short)1).setCellStyle(cellStyle1);
		   
			row51.createCell((short)2);
			row51.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_set_data","help",doc);
		    row51.createCell((short)3).setCellValue(value);
		    row51.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_set_data",doc);
		    row51.createCell((short)4).setCellValue(value);
		    row51.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row52
		    HSSFRow row52 = sheet2.createRow((short)51);
		    sub_chapter_number = findAttributeValue("validation_set_descriptors","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_set_descriptors","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row52.createCell((short)1).setCellValue(value);
			row52.getCell((short)1).setCellStyle(cellStyle1);
		   
			row52.createCell((short)2);
			row52.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_set_descriptors","help",doc);
		    row52.createCell((short)3).setCellValue(value);
		    row52.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_set_descriptors",doc);
		    row52.createCell((short)4).setCellValue(value);
		    row52.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row53
		    HSSFRow row53 = sheet2.createRow((short)52);
		    sub_chapter_number = findAttributeValue("validation_dependent_var_availability","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_dependent_var_availability","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row53.createCell((short)1).setCellValue(value);
			row53.getCell((short)1).setCellStyle(cellStyle1);
		   
			row53.createCell((short)2);
			row53.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_dependent_var_availability","help",doc);
		    row53.createCell((short)3).setCellValue(value);
		    row53.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_dependent_var_availability",doc);
		    row53.createCell((short)4).setCellValue(value);
		    row53.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row54
		    HSSFRow row54 = sheet2.createRow((short)53);
		    sub_chapter_number = findAttributeValue("validation_other_info","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_other_info","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row54.createCell((short)1).setCellValue(value);
			row54.getCell((short)1).setCellStyle(cellStyle1);
		   
			row54.createCell((short)2);
			row54.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_other_info","help",doc);
		    row54.createCell((short)3).setCellValue(value);
		    row54.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_other_info",doc);
		    row54.createCell((short)4).setCellValue(value);
		    row54.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row55
		    HSSFRow row55 = sheet2.createRow((short)54);
		    sub_chapter_number = findAttributeValue("experimental_design","chapter", doc);
			sub_chapter_name = findAttributeValue("experimental_design","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row55.createCell((short)1).setCellValue(value);
			row55.getCell((short)1).setCellStyle(cellStyle1);
		   
			row55.createCell((short)2);
			row55.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("experimental_design","help",doc);
		    row55.createCell((short)3).setCellValue(value);
		    row55.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("experimental_design",doc);
		    row55.createCell((short)4).setCellValue(value);
		    row55.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row56
		    HSSFRow row56 = sheet2.createRow((short)55);
		    sub_chapter_number = findAttributeValue("validation_predictivity","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_predictivity","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row56.createCell((short)1).setCellValue(value);
			row56.getCell((short)1).setCellStyle(cellStyle1);
		   
			row56.createCell((short)2);
			row56.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_predictivity","help",doc);
		    row56.createCell((short)3).setCellValue(value);
		    row56.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_predictivity",doc);
		    row56.createCell((short)4).setCellValue(value);
		    row56.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row57
		    HSSFRow row57 = sheet2.createRow((short)56);
		    sub_chapter_number = findAttributeValue("validation_predictivity","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_predictivity","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row57.createCell((short)1).setCellValue(value);
			row57.getCell((short)1).setCellStyle(cellStyle1);
		   
			row57.createCell((short)2);
			row57.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_predictivity","help",doc);
		    row57.createCell((short)3).setCellValue(value);
		    row57.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_predictivity",doc);
		    row57.createCell((short)4).setCellValue(value);
		    row57.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row58
		    HSSFRow row58 = sheet2.createRow((short)57);
		    sub_chapter_number = findAttributeValue("validation_comments","chapter", doc);
			sub_chapter_name = findAttributeValue("validation_comments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row58.createCell((short)1).setCellValue(value);
			row58.getCell((short)1).setCellStyle(cellStyle1);
		   
			row58.createCell((short)2);
			row58.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("validation_comments","help",doc);
		    row58.createCell((short)3).setCellValue(value);
		    row58.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("validation_comments",doc);
		    row58.createCell((short)4).setCellValue(value);
		    row58.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row59
		    HSSFRow row59 = sheet2.createRow((short)58);
		    chapter = findAttributeValue("QSAR_Interpretation","chapter", doc);
			name = findAttributeValue("QSAR_Interpretation","name", doc);
			value = chapter+". "+ name;	   


			row59.createCell((short)0).setCellValue(value);
			row59.getCell((short)0).setCellStyle(green_cellStyle_chapter);

			row59.createCell((short)1);
			row59.getCell((short)1).setCellStyle(green_cellStyle_subchapter_first);
			row59.createCell((short)2);
			row59.getCell((short)2).setCellStyle(green_cellStyle_subchapter_first);
			row59.createCell((short)3);
			row59.getCell((short)3).setCellStyle(cellStyle_help_text_green_first);
			row59.createCell((short)4);
			row59.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green_first);

			sheet2.addMergedRegion(new Region(58,(short)0,61,(short)0));
			
			//row60
		    HSSFRow row60 = sheet2.createRow((short)59);	    
		    sub_chapter_number = findAttributeValue("mechanistic_basis","chapter", doc);
			sub_chapter_name = findAttributeValue("mechanistic_basis","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row60.createCell((short)1).setCellValue(value);
			row60.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row60.createCell((short)2);
			row60.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("mechanistic_basis","help",doc);
		    row60.createCell((short)3).setCellValue(value);
		    row60.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("mechanistic_basis",doc);	      
		    row60.createCell((short)4).setCellValue(value);	    	
		    row60.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row61
		    HSSFRow row61 = sheet2.createRow((short)60);	    
		    sub_chapter_number = findAttributeValue("mechanistic_basis_comments","chapter", doc);
			sub_chapter_name = findAttributeValue("mechanistic_basis_comments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row61.createCell((short)1).setCellValue(value);
			row61.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row61.createCell((short)2);
			row61.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("mechanistic_basis_comments","help",doc);
		    row61.createCell((short)3).setCellValue(value);
		    row61.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("mechanistic_basis_comments",doc);	      
		    row61.createCell((short)4).setCellValue(value);	    	
		    row61.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row62
		    HSSFRow row62 = sheet2.createRow((short)61);	    
		    sub_chapter_number = findAttributeValue("mechanistic_basis_info","chapter", doc);
			sub_chapter_name = findAttributeValue("mechanistic_basis_info","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row62.createCell((short)1).setCellValue(value);
			row62.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row62.createCell((short)2);
			row62.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("mechanistic_basis_info","help",doc);
		    row62.createCell((short)3).setCellValue(value);
		    row62.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("mechanistic_basis_info",doc);	      
		    row62.createCell((short)4).setCellValue(value);	    	
		    row62.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row63
		    HSSFRow row63 = sheet2.createRow((short)62);
		    chapter = findAttributeValue("QSAR_Miscelaneous","chapter", doc);
			name = findAttributeValue("QSAR_Miscelaneous","name", doc);
			value = chapter+". "+ name;	   
			row63.createCell((short)0).setCellValue(value);	   
			row63.getCell((short)0).setCellStyle(cellStyle_chapter);
		   
		    sheet2.addMergedRegion(new Region(62,(short)0,65,(short)0));
		    	    
		    row63.createCell((short)1);
		    row63.getCell((short)1).setCellStyle(cellStyle_yellow_subchapter_first);
		    row63.createCell((short)2);
		    row63.getCell((short)2).setCellStyle(cellStyle_yellow_subchapter_first);
		    
		    row63.createCell((short)3);
		    row63.getCell((short)3).setCellStyle(cellStyle_yellow_help_text_first);
		    row63.createCell((short)4);
		    row63.getCell((short)4).setCellStyle(cellStyle_dynamic_text_first);
		    
		    //row64
		    HSSFRow row64 = sheet2.createRow((short)63);
		    sub_chapter_number = findAttributeValue("comments","chapter", doc);
			sub_chapter_name = findAttributeValue("comments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row64.createCell((short)1).setCellValue(value);
			row64.getCell((short)1).setCellStyle(cellStyle1);
		   
			row64.createCell((short)2);
			row64.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("comments","help",doc);
		    row64.createCell((short)3).setCellValue(value);
		    row64.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("comments",doc);
		    row64.createCell((short)4).setCellValue(value);
		    row64.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row65
		    HSSFRow row65 = sheet2.createRow((short)64);
		    sub_chapter_number = findAttributeValue("bibliography","chapter", doc);
			sub_chapter_name = findAttributeValue("bibliography","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row65.createCell((short)1).setCellValue(value);
			row65.getCell((short)1).setCellStyle(cellStyle1);
		   
			row65.createCell((short)2);
			row65.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("bibliography","help",doc);
		    row65.createCell((short)3).setCellValue(value);
		    row65.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("bibliography",doc);
		    row65.createCell((short)4).setCellValue(value);
		    row65.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row66
		    HSSFRow row66 = sheet2.createRow((short)65);
		    sub_chapter_number = findAttributeValue("attachments","chapter", doc);
			sub_chapter_name = findAttributeValue("attachments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row66.createCell((short)1).setCellValue(value);
			row66.getCell((short)1).setCellStyle(cellStyle1);
		   
			row66.createCell((short)2);
			row66.getCell((short)2).setCellStyle(cellStyle1);
		    
		    value = findAttributeValue("attachments","help",doc);
		    row66.createCell((short)3).setCellValue(value);
		    row66.getCell((short)3).setCellStyle(cellStyle_help_text);
		    
		    value = findNodeValue("attachments",doc);
		    row66.createCell((short)4).setCellValue(value);
		    row66.getCell((short)4).setCellStyle(cellStyle_dynamic_text);
		    
		    //row67
		    HSSFRow row67 = sheet2.createRow((short)66);
		    chapter = findAttributeValue("QMRF_Summary","chapter", doc);
			name = findAttributeValue("QMRF_Summary","name", doc);
			value = chapter+". "+ name;	   


		    row67.createCell((short)0).setCellValue(value);
		    row67.getCell((short)0).setCellStyle(green_cellStyle_chapter);

		    row67.createCell((short)1);
		    row67.getCell((short)1).setCellStyle(green_cellStyle_subchapter_first);
		    row67.createCell((short)2);
		    row67.getCell((short)2).setCellStyle(green_cellStyle_subchapter_first);
		    row67.createCell((short)3);
		    row67.getCell((short)3).setCellStyle(cellStyle_help_text_green_first);
		    row67.createCell((short)4);
		    row67.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green_first);


		    sheet2.addMergedRegion(new Region(66,(short)0,70,(short)0));
		    
		    //row68
		    HSSFRow row68 = sheet2.createRow((short)67);	    
		    sub_chapter_number = findAttributeValue("QMRF_number","chapter", doc);
			sub_chapter_name = findAttributeValue("QMRF_number","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row68.createCell((short)1).setCellValue(value);
			row68.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row68.createCell((short)2);
			row68.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("QMRF_number","help",doc);
		    row68.createCell((short)3).setCellValue(value);
		    row68.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("QMRF_number",doc);	      
		    row68.createCell((short)4).setCellValue(value);	    	
		    row68.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row69
		    HSSFRow row69 = sheet2.createRow((short)68);	    
		    sub_chapter_number = findAttributeValue("date_publication","chapter", doc);
			sub_chapter_name = findAttributeValue("date_publication","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row69.createCell((short)1).setCellValue(value);
			row69.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row69.createCell((short)2);
			row69.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("date_publication","help",doc);
		    row69.createCell((short)3).setCellValue(value);
		    row69.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("date_publication",doc);	      
		    row69.createCell((short)4).setCellValue(value);	    	
		    row69.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row70
		    HSSFRow row70 = sheet2.createRow((short)69);	    
		    sub_chapter_number = findAttributeValue("keywords","chapter", doc);
			sub_chapter_name = findAttributeValue("keywords","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row70.createCell((short)1).setCellValue(value);
			row70.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row70.createCell((short)2);
			row70.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("keywords","help",doc);
		    row70.createCell((short)3).setCellValue(value);
		    row70.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("keywords",doc);	      
		    row70.createCell((short)4).setCellValue(value);	    	
		    row70.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    //row71
		    HSSFRow row71 = sheet2.createRow((short)70);	    
		    sub_chapter_number = findAttributeValue("summary_comments","chapter", doc);
			sub_chapter_name = findAttributeValue("summary_comments","name", doc);
			value = " "+sub_chapter_number+". "+ sub_chapter_name+":";
			row71.createCell((short)1).setCellValue(value);
			row71.getCell((short)1).setCellStyle(green_cellStyle_subchapter);
			row71.createCell((short)2);
			row71.getCell((short)2).setCellStyle(green_cellStyle_subchapter);
		    value = findAttributeValue("summary_comments","help",doc);
		    row71.createCell((short)3).setCellValue(value);
		    row71.getCell((short)3).setCellStyle(cellStyle_help_text_green);
		    
		    value = findNodeValue("summary_comments",doc);	      
		    row71.createCell((short)4).setCellValue(value);	    	
		    row71.getCell((short)4).setCellStyle(cellStyle_dynamic_text_green);
		    
		    
		    
		    
		    
		    sheet2.autoSizeColumn((short)0);
		    sheet2.autoSizeColumn((short)1);
		    sheet2.autoSizeColumn((short)2);
		    sheet2.autoSizeColumn((short)3);
		    sheet2.autoSizeColumn((short)4);
		    //FileOutputStream fileOut = new FileOutputStream("Qmrf.xls");
		    wb.write(excel);
		    excel.close();		}
		
			catch (SAXParseException err) {
	        System.out.println ("** Parsing error" + ", line "
	             + err.getLineNumber () + ", uri " + err.getSystemId ());
	        System.out.println(" " + err.getMessage ());

	        }catch (SAXException e) {
	        Exception x = e.getException ();
	        ((x == null) ? e : x).printStackTrace ();

	        }catch (Throwable t) {
	        t.printStackTrace ();
	        }
	}
	public static String findNodeValue(String name_node, org.w3c.dom.Document source) {

		source.getDocumentElement();
		NodeList objCatNodes = source.getElementsByTagName(name_node);
		if(objCatNodes.getLength() == 0) return "";
		Node objNode=objCatNodes.item(0);
		NodeList objNodes = objNode.getChildNodes();		
		if(objNodes.getLength() == 0) return "";

		return org.apache.commons.lang.StringEscapeUtils.unescapeXml(replaceTags(objNodes.item(0).getNodeValue()).trim());
	}
	public static String findAttributeValue(String name_node,String name_attribute, org.w3c.dom.Document source) {

		source.getDocumentElement();
		NodeList objCatNodes = source.getElementsByTagName(name_node);
		Node objNode=objCatNodes.item(0);
		NamedNodeMap objAttributes =  objNode.getAttributes();
		Node attribute = objAttributes.getNamedItem(name_attribute);
		return org.apache.commons.lang.StringEscapeUtils.unescapeXml(replaceTags(attribute.getNodeValue()).trim());
	}
	public static String findAttributeValue(String name_attribute, Node source) {
		
		NamedNodeMap objAttributes =  source.getAttributes();
		Node attribute = objAttributes.getNamedItem(name_attribute);
		return org.apache.commons.lang.StringEscapeUtils.unescapeXml(replaceTags(attribute.getNodeValue()).trim());
	}
	public static String replaceTags(String text) {

		Matcher m = CRLF.matcher(text);
		String  newText = "";
		if (m.find()) {
			newText = m.replaceAll("");
		}
		else{
			newText = text;
		}
		
		/*
		
		m = ptag.matcher(newText);
		if (m.find()) {
			newText = m.replaceAll("\n");
		}
		*/

		return newText.trim();
		
		
	}
	public static ArrayList findNodeIDRef(String name_node,String ref_name, String catalog_name, org.w3c.dom.Document source) {

		source.getDocumentElement();
		ArrayList return_list = new ArrayList();
		NodeList objCatNodes = source.getElementsByTagName(name_node);
		
		Node objNode=objCatNodes.item(0);
		NodeList objNodes = objNode.getChildNodes();
		for(int i = 0; i < objNodes.getLength();i=i+1){
			
			if(objNodes.item(i).getNodeName().equals(ref_name)){
				NamedNodeMap objAttributes =  objNodes.item(i).getAttributes();
				Node attribute = objAttributes.getNamedItem("idref");
				//attribute.getNodeValue()
				NodeList objNodesAuthor = source.getElementsByTagName(catalog_name);
				for(int j = 0; j < objNodesAuthor.getLength();j=j+1){
					String id = objNodesAuthor.item(j).getAttributes().getNamedItem("id").getNodeValue();
					if(id.equals(attribute.getNodeValue())){
						//Node name = objNodesAuthor.item(j).getAttributes().getNamedItem("name");
						return_list.add(objNodesAuthor.item(j));
					}
					
					
				}
				
			}
			
		}
		return return_list;
	}
	class  BoldProperty{
		 int StartValue;
		 int EndValue;
		 public BoldProperty(){}
		
	}
	

}
