package ambit.data.qmrf;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import com.lowagie.text.Chunk;
import com.lowagie.text.Document;
import com.lowagie.text.DocumentException;
import com.lowagie.text.Element;
import com.lowagie.text.ElementTags;
import com.lowagie.text.Font;
import com.lowagie.text.Image;
import com.lowagie.text.PageSize;
import com.lowagie.text.Paragraph;
import com.lowagie.text.pdf.BaseFont;
import com.lowagie.text.pdf.PdfContentByte;
import com.lowagie.text.pdf.PdfPCell;
import com.lowagie.text.pdf.PdfPTable;
import com.lowagie.text.pdf.PdfPageEventHelper;
import com.lowagie.text.pdf.PdfTemplate;
import com.lowagie.text.pdf.PdfWriter;
import com.lowagie.text.xml.SAXmyHandler;
import com.lowagie.text.xml.TagMap;
import com.lowagie.text.xml.XmlPeer;
/**
 * Example that takes an XML file, converts it to PDF and adds all kinds of
 * extra's, such as an alternating header, a footer with page x of y, a page
 * with metadata,...
 */
public class Qmrf_Xml_Pdf {
	protected static Pattern CRLF = Pattern.compile("(<html>|</html>|<head>|</head>|<body>|</body>|<b>|</b>|<i>|</i>)");
	protected static Pattern ptag = Pattern.compile("(<p>)");
	protected String BaseFont_Url = "C:/WINDOWS/Fonts/times.ttf" ;

	class MyPageEvents extends PdfPageEventHelper {

		protected InputSource originalXML = null;

		/** This is the contentbyte object of the writer */
		PdfContentByte cb;

		/** we will put the final number of pages in a template */
		PdfTemplate template;

		/** this is the BaseFont we are going to use for the header / footer */
		BaseFont bf = null;




		/**
		 * The first thing to do when the document is opened, is to define the BaseFont,
		 * get the Direct Content object and create the template that will hold the final
		 * number of pages.
		 * @see com.lowagie.text.pdf.PdfPageEventHelper#onOpenDocument(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
		 */
		public void onOpenDocument(PdfWriter writer, Document document) {
			try {
				bf = BaseFont.createFont(BaseFont.TIMES_ROMAN, BaseFont.CP1252,
						BaseFont.NOT_EMBEDDED);
				cb = writer.getDirectContent();
				template = cb.createTemplate(50, 50);

					Image png = Image.getInstance(Qmrf_Xml_Pdf.class.getClassLoader().getResource("ambit/data/qmrf/logo.png"));
					//png.scaleAbsolute(76, 67);
					//png.setAlignment(Image.MIDDLE);

					PdfPCell cell;

					float[] widths = {1f,5f,1f};
					float[] widths1 = {1f};
					PdfPTable table = new PdfPTable(widths);
					PdfPTable table1 = new PdfPTable(widths1);

					table.setWidthPercentage(100);
					//table.addCell(new PdfPCell(png, true));
					png.scalePercent(60);
			        cell = new PdfPCell();
			        cell.setMinimumHeight(70);
		            cell.addElement(new Chunk(png,+14,-40));
					table.addCell(cell);

					String Text ="";
					try{
						DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
						DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
						
						QMRFSchemaResolver resolver = new QMRFSchemaResolver("http://ambit.acad.bg/qmrf/qmrf.dtd",null);
						resolver.setIgnoreSystemID(true);
						docBuilder.setEntityResolver(resolver);
						
						org.w3c.dom.Document doc = docBuilder.parse (originalXML);
	
	
	
						Text = findNodeValue("QMRF_number", doc);
						Chunk ident_title = new Chunk("QMRF identifier (ECB Inventory):");
						Chunk ident_text = new Chunk(Text);
						ident_title.setFont(new Font(Font.TIMES_ROMAN, 12,Font.BOLDITALIC));
						ident_text.setFont(new Font(Font.TIMES_ROMAN, 12,Font.ITALIC));
						Paragraph p = new Paragraph();
						p.add(ident_title);
						p.add(ident_text);
						cell = new PdfPCell(p);
						cell.setHorizontalAlignment(Element.ALIGN_LEFT);
						table1.addCell(cell);
	
						Text = findNodeValue("QSAR_title", doc);					
						ident_title = new Chunk("QMRF Title:");
						ident_text = new Chunk(Text);
						ident_title.setFont(new Font(Font.TIMES_ROMAN, 12,Font.BOLDITALIC));
						ident_text.setFont(new Font(Font.TIMES_ROMAN, 12,Font.ITALIC));
						p = new Paragraph();
						p.add(ident_title);
						p.add(ident_text);
						cell = new PdfPCell(p);
						cell.setHorizontalAlignment(Element.ALIGN_LEFT);
						table1.addCell(cell);
	
	
						java.util.Date now = new java.util.Date();
						java.text.DateFormat df = java.text.DateFormat.getDateInstance();
					    String date = df.format(now);
						ident_title = new Chunk("Printing Date:");
						ident_text = new Chunk(date);
						ident_title.setFont(new Font(Font.TIMES_ROMAN, 12,Font.BOLDITALIC));
						ident_text.setFont(new Font(Font.TIMES_ROMAN, 12,Font.ITALIC));
						p = new Paragraph();
						p.add(ident_title);
						p.add(ident_text);
	
						cell = new PdfPCell(p);
						cell.setHorizontalAlignment(Element.ALIGN_LEFT);
						table1.addCell(cell);
						p = new Paragraph("");
						cell = new PdfPCell(p);
						cell.setHorizontalAlignment(Element.ALIGN_LEFT);
						table1.addCell(cell);
						cell = new PdfPCell(table1);
						cell.setPadding(0f);
						table.addCell(cell);
				}catch (SAXParseException err) {
					        System.out.println ("** Parsing error" + ", line "
					             + err.getLineNumber () + ", uri " + err.getSystemId ());
					        System.out.println(" " + err.getMessage ());
	
		        }catch (SAXException e) {
					        Exception x = e.getException ();
					        ((x == null) ? e : x).printStackTrace ();
	
		        }catch (Throwable t) {
					        t.printStackTrace ();
		        }
	
	
	
						//table.addCell(new PdfPCell(png, true));
		        cell.addElement(new Chunk(png,+14,-40));
						table.addCell(cell);
						document.add(table);
						document.add(new Paragraph(16));
	


			} catch (DocumentException de) {
			} catch (IOException ioe) {
			}
		}


		public void onChapter(PdfWriter writer, Document document,
				float paragraphPosition, Paragraph title) {
			StringBuffer buf = new StringBuffer();
			for (Iterator i = title.getChunks().iterator(); i.hasNext();) {
				Chunk chunk = (Chunk) i.next();
				buf.append(chunk.content());
			}

		}


		public void onEndPage(PdfWriter writer, Document document) {
			/*int pageN = writer.getPageNumber();
			String text = "Page " + pageN + " of ";
			cb.beginText();
			cb.setFontAndSize(bf, 8);
			cb.setTextMatrix(280, 30);
			cb.showText(text);
			cb.endText();*/


		}

		/**
		 * Just before the document is closed, we add the final number of pages to
		 * the template.
		 * @see com.lowagie.text.pdf.PdfPageEventHelper#onCloseDocument(com.lowagie.text.pdf.PdfWriter, com.lowagie.text.Document)
		 */
		public void onCloseDocument(PdfWriter writer, Document document) {
			/*template.beginText();
			template.setFontAndSize(bf, 8);
			template.showText(String.valueOf(writer.getPageNumber() - 1));
			template.endText();*/

		}


		public InputSource getOriginalXML() {
			return originalXML;
		}


		public void setOriginalXML(InputSource originalXML) {
			this.originalXML = originalXML;
		}


	}

	/**
	 * Gets a PageEvents object.
	 * @return a new PageEvents object
	 */
	public MyPageEvents getPageEvents() {
		return new MyPageEvents();
	}
	/**
	 * Gets a Handler object.
	 * @param document  the document on which the handler operates
	 * @return a Handler object
	 */
	public MyHandler getXmlHandler(Document document, InputSource originalXML) {
		try {
			InputStream in = Qmrf_Xml_Pdf.class.getClassLoader().getResourceAsStream("ambit/data/qmrf/tagmapqmrf.xml");
			return new MyHandler(document, new QmrfMap(in,originalXML ));
		} catch (IOException e) {
			e.printStackTrace();
		}
		catch (DocumentException de) {
		} 
		return null;
	}


	/**
	 * Converts a play in XML into PDF.
	 * @param args no arguments needed
	 */
	public static void main(String[] args) {

		System.out.println("QMRF");

		Qmrf_Xml_Pdf x = new Qmrf_Xml_Pdf();
		try {
			//this will not work , because of the second stream reading while the first is closing....
			//x.xml2pdf(new FileReader("myqmrf.xml"),new FileOutputStream("Qmrf.pdf"));
			x.xml2pdf("myqmrf.xml",new FileOutputStream("Qmrf.pdf"));
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	
	public void xml2pdf(Reader xml, OutputStream pdf) {
		// step 1: creation of a document-object
		Document document = new Document(PageSize.A4, 80, 50, 30, 65);

		try {
			// step 2:
			// we create a writer that listens to the document
			// and directs a XML-stream to a file
			PdfWriter writer = PdfWriter.getInstance(document,pdf);

			// create add the event handler
			MyPageEvents events = new Qmrf_Xml_Pdf().getPageEvents();
			writer.setPageEvent(events);
			events.setOriginalXML(new InputSource(xml));

			// step 3: we create a parser and set the document handler
			SAXParser parser = SAXParserFactory.newInstance().newSAXParser();

			//this will not work , because of the second stream ....
			
			// step 4: we parse the document
			parser.parse(Qmrf_Xml_Pdf.class.getClassLoader().getResourceAsStream("ambit/data/qmrf/qmrf_pdf_template.xml"),
					new Qmrf_Xml_Pdf().getXmlHandler(document, new InputSource(xml)));

			document.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.err.println(e.getMessage());
		}		
	}
	
	
	public void xml2pdf(String xml, OutputStream pdf) {
		// step 1: creation of a document-object
		Document document = new Document(PageSize.A4, 80, 50, 30, 65);

		try {
			// step 2:
			// we create a writer that listens to the document
			// and directs a XML-stream to a file
			PdfWriter writer = PdfWriter.getInstance(document,pdf);

			// create add the event handler
			MyPageEvents events = new Qmrf_Xml_Pdf().getPageEvents();
			writer.setPageEvent(events);
			events.setOriginalXML(new InputSource(new StringReader(xml)));

			// step 3: we create a parser and set the document handler
			SAXParser parser = SAXParserFactory.newInstance().newSAXParser();

			
			
			// step 4: we parse the document
			parser.parse(Qmrf_Xml_Pdf.class.getClassLoader().getResourceAsStream("ambit/data/qmrf/qmrf_pdf_template.xml"),
					new Qmrf_Xml_Pdf().getXmlHandler(document, new InputSource(new StringReader(xml))));

			document.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.err.println(e.getMessage());
		}		
	}
		
	
	class MyHandler extends SAXmyHandler {

	
		public MyHandler(Document document, HashMap tagmap) throws DocumentException,IOException {
			super(document, tagmap);
		}


		public void endElement(String uri, String lname, String name) {
			if (myTags.containsKey(name)) {
				XmlPeer peer = (XmlPeer) myTags.get(name);
				// we don't want the document to be close
				// because we are going to add a page after the xml is parsed
				if (isDocumentRoot(peer.getTag())) {
					return;
				}
				handleEndingTags(peer.getTag());
			} else {
				handleEndingTags(name);
			}
		}
	}



	class QmrfMap extends TagMap {

		private static final long serialVersionUID = 1024517625414654121L;

		/**
		 * Constructs a TagMap based on an XML file
		 * and/or on XmlPeer objects that are added.
		 * @throws IOException
		 */
		public QmrfMap(InputStream in, InputSource originalXML) throws IOException {
			super(in);
			try {
				DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
				DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
				
				QMRFSchemaResolver resolver = new QMRFSchemaResolver("http://ambit.acad.bg/qmrf/qmrf.dtd",null);
				resolver.setIgnoreSystemID(true);
				docBuilder.setEntityResolver(resolver);

				
				org.w3c.dom.Document doc = docBuilder.parse (originalXML );
				XmlPeer peer = new XmlPeer(ElementTags.CHUNK, "QSAR_identifier");
				String chapter = "";
				String name = "";
				String value = "";
				chapter = findAttributeValue("QSAR_identifier","chapter", doc);
				name = findAttributeValue("QSAR_identifier","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				
				
				
				
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_General_information");
				chapter = findAttributeValue("QSAR_General_information","chapter", doc);
				name = findAttributeValue("QSAR_General_information","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Endpoint");
				chapter = findAttributeValue("QSAR_Endpoint","chapter", doc);
				name = findAttributeValue("QSAR_Endpoint","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Algorithm");
				chapter = findAttributeValue("QSAR_Algorithm","chapter", doc);
				name = findAttributeValue("QSAR_Algorithm","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Applicability_domain");
				chapter = findAttributeValue("QSAR_Applicability_domain","chapter", doc);
				name = findAttributeValue("QSAR_Applicability_domain","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Robustness");
				chapter = findAttributeValue("QSAR_Robustness","chapter", doc);
				name = findAttributeValue("QSAR_Robustness","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Predictivity");
				chapter = findAttributeValue("QSAR_Predictivity","chapter", doc);
				name = findAttributeValue("QSAR_Predictivity","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Interpretation");
				chapter = findAttributeValue("QSAR_Interpretation","chapter", doc);
				name = findAttributeValue("QSAR_Interpretation","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_Miscelaneous");
				chapter = findAttributeValue("QSAR_Miscelaneous","chapter", doc);
				name = findAttributeValue("QSAR_Miscelaneous","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QMRF_Summary");
				chapter = findAttributeValue("QMRF_Summary","chapter", doc);
				name = findAttributeValue("QMRF_Summary","name", doc);
				value = chapter+". "+ name;
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);


				String sub_chapter_number = "";
				String sub_chapter_name = "";
				String sub_chapter_text= "";

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_title");
				sub_chapter_number = findAttributeValue("QSAR_title","chapter", doc);
				sub_chapter_name = findAttributeValue("QSAR_title","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_title_text");
				sub_chapter_text = findNodeValue("QSAR_title", doc);
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.FONT,BaseFont_Url);				
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_models");
				sub_chapter_number = findAttributeValue("QSAR_models","chapter", doc);
				sub_chapter_name = findAttributeValue("QSAR_models","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";				
				peer.addValue(ElementTags.SIZE, "12");					
				peer.addValue(ElementTags.STYLE,"font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);	
				peer.setContent(value);
				
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_models_text");
				sub_chapter_text = findNodeValue("QSAR_models", doc);
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_software");
				sub_chapter_number = findAttributeValue("QSAR_software","chapter", doc);
				sub_chapter_name = findAttributeValue("QSAR_software","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QSAR_software_text");
				sub_chapter_text = findNodeValue("QSAR_models", doc);
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);




				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_date");
				sub_chapter_number = findAttributeValue("qmrf_date","chapter", doc);
				sub_chapter_name = findAttributeValue("qmrf_date","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";	
				peer.addValue(ElementTags.SIZE, "12");					
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_date_text");
				sub_chapter_text = findNodeValue("qmrf_date", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);
				
				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_authors");
				sub_chapter_number = findAttributeValue("qmrf_authors","chapter", doc);
				sub_chapter_name = findAttributeValue("qmrf_authors","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";	
				peer.addValue(ElementTags.SIZE, "12");					
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);				
				
				value = "";
			    ArrayList qmrf_authors_list = findNodeIDRef("qmrf_authors","author_ref", "author", doc);
			    for (Iterator it = qmrf_authors_list.iterator(); it.hasNext(); ) {
			    	   Node qmrf_authors = (Node)it.next();
			    	   if(findAttributeValue("name",qmrf_authors).trim().length() > 0 ){
			    	   value += findAttributeValue("name",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("affiliation",qmrf_authors).trim().length() > 0 ){
			   	       value += findAttributeValue("affiliation",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("contact",qmrf_authors).trim().length() > 0 ){
			 	   	      
			   	       value += findAttributeValue("contact",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("email",qmrf_authors).trim().length() > 0 ){
				 	   	   
			   	       value += findAttributeValue("email",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("url",qmrf_authors).trim().length() > 0 ){
					 	   
			   	       value += findAttributeValue("url",qmrf_authors);
			   	       value += "\n";
			    	   }
			    }
			    
			    peer = new XmlPeer(ElementTags.CHUNK, "qmrf_authors_text");
				sub_chapter_text = value;
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_date_revision");
				sub_chapter_number = findAttributeValue("qmrf_date_revision","chapter", doc);
				sub_chapter_name = findAttributeValue("qmrf_date_revision","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_date_revision_text");
				sub_chapter_text = findNodeValue("qmrf_date_revision", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_revision");
				sub_chapter_number = findAttributeValue("qmrf_revision","chapter", doc);
				sub_chapter_name = findAttributeValue("qmrf_revision","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";	
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "qmrf_revision_text");
				sub_chapter_text = findNodeValue("qmrf_revision", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "model_authors");
				sub_chapter_number = findAttributeValue("model_authors","chapter", doc);
				sub_chapter_name = findAttributeValue("model_authors","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";	
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);
				
				value = "";
			    ArrayList model_authors_list = findNodeIDRef("model_authors","author_ref", "author", doc);
			    for (Iterator it = model_authors_list.iterator(); it.hasNext(); ) {
			    	   Node qmrf_authors = (Node)it.next();
			    	   if(findAttributeValue("name",qmrf_authors).trim().length() > 0 ){
			    	   value += findAttributeValue("name",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("affiliation",qmrf_authors).trim().length() > 0 ){
			   	       value += findAttributeValue("affiliation",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("contact",qmrf_authors).trim().length() > 0 ){
			 	   	      
			   	       value += findAttributeValue("contact",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("email",qmrf_authors).trim().length() > 0 ){
				 	   	   
			   	       value += findAttributeValue("email",qmrf_authors);
			   	       value += "\n";
			    	   }
			    	   if(findAttributeValue("url",qmrf_authors).trim().length() > 0 ){
					 	   
			   	       value += findAttributeValue("url",qmrf_authors);
			   	       value += "\n";
			    	   }
			    }

				peer = new XmlPeer(ElementTags.CHUNK, "model_authors_text");
				//sub_chapter_text = findNodeValue("model_authors", doc);
				sub_chapter_text = value;
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "model_date");
				sub_chapter_number = findAttributeValue("model_date","chapter", doc);
				sub_chapter_name = findAttributeValue("model_date","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "model_date_text");
				sub_chapter_text = findNodeValue("model_date", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);
				
				

				peer = new XmlPeer(ElementTags.CHUNK, "references");
				sub_chapter_number = findAttributeValue("references","chapter", doc);
				sub_chapter_name = findAttributeValue("references","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);
				
				value = "";	
				String prefix = "";
				int num = 1;
			    ArrayList publication_list = findNodeIDRef("references","publication_ref", "publication", doc);
		       	for (Iterator it = publication_list.iterator(); it.hasNext(); ) {
			    	   Node publication = (Node)it.next();		    	   
			    	   if(findAttributeValue("title",publication).trim().length() > 0 ){
			    		   prefix = "["+num+"]";			    	 
			    		   value +=  prefix +  findAttributeValue("title",publication);
			    		   value += "\n";
			    	   }
			    	   num++;
			    	   
			    }

				peer = new XmlPeer(ElementTags.CHUNK, "references_text");
				sub_chapter_text = value;
				//sub_chapter_text = findNodeValue("references", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "info_availability");
				sub_chapter_number = findAttributeValue("info_availability","chapter", doc);
				sub_chapter_name = findAttributeValue("info_availability","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "info_availability_text");
				sub_chapter_text = findNodeValue("info_availability", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "related_models");
				sub_chapter_number = findAttributeValue("related_models","chapter", doc);
				sub_chapter_name = findAttributeValue("related_models","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "related_models_text");
				sub_chapter_text = findNodeValue("related_models", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "model_species");
				sub_chapter_number = findAttributeValue("model_species","chapter", doc);
				sub_chapter_name = findAttributeValue("model_species","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "model_species_text");
				sub_chapter_text = findNodeValue("model_species", doc);
				peer.setContent(sub_chapter_text);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "model_endpoint");
				sub_chapter_number = findAttributeValue("model_endpoint","chapter", doc);
				sub_chapter_name = findAttributeValue("model_endpoint","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";	
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);
				
				value = "";
			    ArrayList model_endpoints_list = findNodeIDRef("model_endpoint","endpoint_ref", "endpoint", doc);
			    for (Iterator it = model_endpoints_list.iterator(); it.hasNext(); ) {
				   Node qmrf_endpoints = (Node)it.next();
				   if(findAttributeValue("name",qmrf_endpoints).trim().length() > 0 ){
				   value += findAttributeValue("name",qmrf_endpoints);
				       value += "\n";
				   }
			    	    	  
			    }	

				peer = new XmlPeer(ElementTags.CHUNK, "model_endpoint_text");
				sub_chapter_text = value;
				//sub_chapter_text = findNodeValue("model_endpoint", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_comments");
				sub_chapter_number = findAttributeValue("endpoint_comments","chapter", doc);
				sub_chapter_name = findAttributeValue("endpoint_comments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_comments_text");
				sub_chapter_text = findNodeValue("endpoint_comments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_units");
				sub_chapter_number = findAttributeValue("endpoint_units","chapter", doc);
				sub_chapter_name = findAttributeValue("endpoint_units","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_units_text");
				sub_chapter_text = findNodeValue("endpoint_units", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_variable");
				sub_chapter_number = findAttributeValue("endpoint_variable","chapter", doc);
				sub_chapter_name = findAttributeValue("endpoint_variable","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");		
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_variable_text");
				sub_chapter_text = findNodeValue("endpoint_variable", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_protocol");
				sub_chapter_number = findAttributeValue("endpoint_protocol","chapter", doc);
				sub_chapter_name = findAttributeValue("endpoint_protocol","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_protocol_text");
				sub_chapter_text = findNodeValue("endpoint_protocol", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_data_quality");
				sub_chapter_number = findAttributeValue("endpoint_data_quality","chapter", doc);
				sub_chapter_name = findAttributeValue("endpoint_data_quality","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "endpoint_data_quality_text");
				sub_chapter_text = findNodeValue("endpoint_data_quality", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "algorithm_type");
				sub_chapter_number = findAttributeValue("algorithm_type","chapter", doc);
				sub_chapter_name = findAttributeValue("algorithm_type","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "algorithm_type_text");
				sub_chapter_text = findNodeValue("algorithm_type", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "algorithm_explicit");
				sub_chapter_number = findAttributeValue("algorithm_explicit","chapter", doc);
				sub_chapter_name = findAttributeValue("algorithm_explicit","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);
				
				value = "";
			    ArrayList algorithm_list = findNodeIDRef("algorithm_explicit","algorithm_ref", "algorithm", doc);
			    for (Iterator it = algorithm_list.iterator(); it.hasNext(); ) {
				   Node qmrf_algorithms = (Node)it.next();
				   if(findAttributeValue("definition",qmrf_algorithms).trim().length() > 0 ){
				   value += findAttributeValue("definition",qmrf_algorithms);
				       value += "\n";
				   }
				   if(findAttributeValue("description",qmrf_algorithms).trim().length() > 0 ){
				       value += findAttributeValue("description",qmrf_algorithms);
				       value += "\n";
				   }
				   
			    }
				peer = new XmlPeer(ElementTags.CHUNK, "algorithm_explicit_text");
				//sub_chapter_text = findNodeValue("algorithm_explicit", doc);
				sub_chapter_text = value;
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "algorithm_comments");
				sub_chapter_number = findAttributeValue("algorithm_comments","chapter", doc);
				sub_chapter_name = findAttributeValue("algorithm_comments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "algorithm_comments_text");
				sub_chapter_text = findNodeValue("algorithm_comments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "algorithms_descriptors");
				sub_chapter_number = findAttributeValue("algorithms_descriptors","chapter", doc);
				sub_chapter_name = findAttributeValue("algorithms_descriptors","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);
				
				value = "";
			    ArrayList descriptor_list = findNodeIDRef("algorithms_descriptors","descriptor_ref", "descriptor", doc);
			    
			    for (Iterator it = descriptor_list.iterator(); it.hasNext(); ) {
				   Node qmrf_descriptors = (Node)it.next();		    	   
				   if(findAttributeValue("name",qmrf_descriptors).trim().length() > 0 ){
				   value += findAttributeValue("name",qmrf_descriptors);
				       
				   }
				   if(findAttributeValue("units",qmrf_descriptors).trim().length() > 0 ){
					   value += ",";
					   value += findAttributeValue("units",qmrf_descriptors);
				      
				   }
				   
				   if(findAttributeValue("description",qmrf_descriptors).trim().length() > 0 ){
					   value += " ";	
				       value += findAttributeValue("description",qmrf_descriptors);
				       value += "\n";
				   }		   
			    }
			    

				peer = new XmlPeer(ElementTags.CHUNK, "algorithms_descriptors_text");
				//sub_chapter_text = findNodeValue("algorithms_descriptors", doc);
				sub_chapter_text = value;				
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "descriptors_selection");
				sub_chapter_number = findAttributeValue("descriptors_selection","chapter", doc);
				sub_chapter_name = findAttributeValue("descriptors_selection","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "descriptors_selection_text");
				sub_chapter_text = findNodeValue("descriptors_selection", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "descriptors_generation");
				sub_chapter_number = findAttributeValue("descriptors_generation","chapter", doc);
				sub_chapter_name = findAttributeValue("descriptors_generation","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "descriptors_generation_text");
				sub_chapter_text = findNodeValue("descriptors_generation", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "descriptors_generation_software");
				sub_chapter_number = findAttributeValue("descriptors_generation_software","chapter", doc);
				sub_chapter_name = findAttributeValue("descriptors_generation_software","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "descriptors_generation_software_text");
				sub_chapter_text = findNodeValue("descriptors_generation_software", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "app_domain_description");
				sub_chapter_number = findAttributeValue("app_domain_description","chapter", doc);
				sub_chapter_name = findAttributeValue("app_domain_description","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "app_domain_description_text");
				sub_chapter_text = findNodeValue("app_domain_description", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "app_domain_method");
				sub_chapter_number = findAttributeValue("app_domain_method","chapter", doc);
				sub_chapter_name = findAttributeValue("app_domain_method","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "app_domain_method_text");
				sub_chapter_text = findNodeValue("app_domain_method", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "app_domain_software");
				sub_chapter_number = findAttributeValue("app_domain_software","chapter", doc);
				sub_chapter_name = findAttributeValue("app_domain_software","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "app_domain_software_text");
				sub_chapter_text = findNodeValue("app_domain_software", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "applicability_limits");
				sub_chapter_number = findAttributeValue("applicability_limits","chapter", doc);
				sub_chapter_name = findAttributeValue("applicability_limits","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "applicability_limits_text");
				sub_chapter_text = findNodeValue("applicability_limits", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "training_set_availability");
				sub_chapter_number = findAttributeValue("training_set_availability","chapter", doc);
				sub_chapter_name = findAttributeValue("training_set_availability","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "training_set_availability_text");
				sub_chapter_text = findNodeValue("training_set_availability", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "training_set_data");
				sub_chapter_number = findAttributeValue("training_set_data","chapter", doc);
				sub_chapter_name = findAttributeValue("training_set_data","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.addValue(ElementTags.SIZE, "12");		
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "training_set_data_text");
				sub_chapter_text = findNodeValue("training_set_data", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "training_set_descriptors");
				sub_chapter_number = findAttributeValue("training_set_descriptors","chapter", doc);
				sub_chapter_name = findAttributeValue("training_set_descriptors","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "training_set_descriptors_text");
				sub_chapter_text = findNodeValue("training_set_descriptors", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "dependent_var_availability");
				sub_chapter_number = findAttributeValue("dependent_var_availability","chapter", doc);
				sub_chapter_name = findAttributeValue("dependent_var_availability","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "dependent_var_availability_text");
				sub_chapter_text = findNodeValue("dependent_var_availability", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "other_info");
				sub_chapter_number = findAttributeValue("other_info","chapter", doc);
				sub_chapter_name = findAttributeValue("other_info","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "other_info_text");
				sub_chapter_text = findNodeValue("other_info", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "preprocessing");
				sub_chapter_number = findAttributeValue("preprocessing","chapter", doc);
				sub_chapter_name = findAttributeValue("preprocessing","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "preprocessing_text");
				sub_chapter_text = findNodeValue("preprocessing", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "goodness_of_fit");
				sub_chapter_number = findAttributeValue("goodness_of_fit","chapter", doc);
				sub_chapter_name = findAttributeValue("goodness_of_fit","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "goodness_of_fit_text");
				sub_chapter_text = findNodeValue("goodness_of_fit", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "loo");
				sub_chapter_number = findAttributeValue("loo","chapter", doc);
				sub_chapter_name = findAttributeValue("loo","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "loo_text");
				sub_chapter_text = findNodeValue("loo", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "lmo");
				sub_chapter_number = findAttributeValue("lmo","chapter", doc);
				sub_chapter_name = findAttributeValue("lmo","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "lmo_text");
				sub_chapter_text = findNodeValue("lmo", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "yscrambling");
				sub_chapter_number = findAttributeValue("yscrambling","chapter", doc);
				sub_chapter_name = findAttributeValue("yscrambling","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "yscrambling_text");
				sub_chapter_text = findNodeValue("yscrambling", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "bootstrap");
				sub_chapter_number = findAttributeValue("bootstrap","chapter", doc);
				sub_chapter_name = findAttributeValue("bootstrap","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "bootstrap_text");
				sub_chapter_text = findNodeValue("bootstrap", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "other_statistics");
				sub_chapter_number = findAttributeValue("other_statistics","chapter", doc);
				sub_chapter_name = findAttributeValue("other_statistics","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "other_statistics_text");
				sub_chapter_text = findNodeValue("other_statistics", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_set_availability");
				sub_chapter_number = findAttributeValue("validation_set_availability","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_set_availability","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_set_availability_text");
				sub_chapter_text = findNodeValue("validation_set_availability", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_set_data");
				sub_chapter_number = findAttributeValue("validation_set_data","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_set_data","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_set_data_text");
				sub_chapter_text = findNodeValue("validation_set_data", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_set_descriptors");
				sub_chapter_number = findAttributeValue("validation_set_descriptors","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_set_descriptors","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_set_descriptors_text");
				sub_chapter_text = findNodeValue("validation_set_descriptors", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_dependent_var_availability");
				sub_chapter_number = findAttributeValue("validation_dependent_var_availability","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_dependent_var_availability","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_dependent_var_availability_text");
				sub_chapter_text = findNodeValue("validation_dependent_var_availability", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_other_info");
				sub_chapter_number = findAttributeValue("validation_other_info","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_other_info","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_other_info_text");
				sub_chapter_text = findNodeValue("validation_other_info", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "experimental_design");
				sub_chapter_number = findAttributeValue("experimental_design","chapter", doc);
				sub_chapter_name = findAttributeValue("experimental_design","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "experimental_design_text");
				sub_chapter_text = findNodeValue("experimental_design", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_predictivity");
				sub_chapter_number = findAttributeValue("validation_predictivity","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_predictivity","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_predictivity_text");
				sub_chapter_text = findNodeValue("validation_predictivity", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_assessment");
				sub_chapter_number = findAttributeValue("validation_assessment","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_assessment","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_assessment_text");
				sub_chapter_text = findNodeValue("validation_assessment", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_comments");
				sub_chapter_number = findAttributeValue("validation_comments","chapter", doc);
				sub_chapter_name = findAttributeValue("validation_comments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "validation_comments_text");
				sub_chapter_text = findNodeValue("validation_comments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "mechanistic_basis");
				sub_chapter_number = findAttributeValue("mechanistic_basis","chapter", doc);
				sub_chapter_name = findAttributeValue("mechanistic_basis","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "mechanistic_basis_text");
				sub_chapter_text = findNodeValue("mechanistic_basis", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "mechanistic_basis_comments");
				sub_chapter_number = findAttributeValue("mechanistic_basis_comments","chapter", doc);
				sub_chapter_name = findAttributeValue("mechanistic_basis_comments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";		
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "mechanistic_basis_comments_text");
				sub_chapter_text = findNodeValue("mechanistic_basis_comments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "mechanistic_basis_info");
				sub_chapter_number = findAttributeValue("mechanistic_basis_info","chapter", doc);
				sub_chapter_name = findAttributeValue("mechanistic_basis_info","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "mechanistic_basis_info_text");
				sub_chapter_text = findNodeValue("mechanistic_basis_info", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "comments");
				sub_chapter_number = findAttributeValue("comments","chapter", doc);
				sub_chapter_name = findAttributeValue("comments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "comments_text");
				sub_chapter_text = findNodeValue("comments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "bibliography");
				sub_chapter_number = findAttributeValue("bibliography","chapter", doc);
				sub_chapter_name = findAttributeValue("bibliography","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "bibliography_text");
				sub_chapter_text = findNodeValue("bibliography", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "attachments");
				sub_chapter_number = findAttributeValue("attachments","chapter", doc);
				sub_chapter_name = findAttributeValue("attachments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "attachments_text");
				sub_chapter_text = findNodeValue("attachments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QMRF_number");
				sub_chapter_number = findAttributeValue("QMRF_number","chapter", doc);
				sub_chapter_name = findAttributeValue("QMRF_number","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "QMRF_number_text");
				sub_chapter_text = findNodeValue("QMRF_number", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "date_publication");
				sub_chapter_number = findAttributeValue("date_publication","chapter", doc);
				sub_chapter_name = findAttributeValue("date_publication","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");		
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "date_publication_text");
				sub_chapter_text = findNodeValue("date_publication", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "keywords");
				sub_chapter_number = findAttributeValue("keywords","chapter", doc);
				sub_chapter_name = findAttributeValue("keywords","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "keywords_text");
				sub_chapter_text = findNodeValue("keywords", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "summary_comments");
				sub_chapter_number = findAttributeValue("summary_comments","chapter", doc);
				sub_chapter_name = findAttributeValue("summary_comments","name", doc);
				value = " "+sub_chapter_number+".    "+ sub_chapter_name+":";
				peer.addValue(ElementTags.SIZE, "12");	
				peer.addValue(ElementTags.STYLE," font-weight: bold");
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "summary_comments_text");
				sub_chapter_text = findNodeValue("summary_comments", doc);
				peer.addValue(ElementTags.FONT,BaseFont_Url);
				peer.setContent(sub_chapter_text);
				put(peer.getAlias(), peer);




				//QMRF INFO
				peer = new XmlPeer(ElementTags.CHUNK, "QMRF_NAME");
				value = " "+findAttributeValue("QMRF","name", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "VERSION");
				value = " "+findAttributeValue("QMRF","version", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "EMAIL");
				value = " "+findAttributeValue("QMRF","email", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "CONTACT");
				value = " "+findAttributeValue("QMRF","contact", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "DATE");
				value = " "+findAttributeValue("QMRF","date", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "AUTHOR");
				value = " "+findAttributeValue("QMRF","author", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);

				peer = new XmlPeer(ElementTags.CHUNK, "URL");
				value = " "+findAttributeValue("QMRF","url", doc);
				peer.setContent(value);
				put(peer.getAlias(), peer);
				
				/*peer = new XmlPeer(ElementTags.CELL, "QMRF_chapter_items_cell");
				peer.addValue(ElementTags.HORIZONTALALIGN,"Middle");	
				peer.addValue(ElementTags.COLSPAN,"2");
				put(peer.getAlias(), peer);*/




			}catch (SAXParseException err) {
		        System.out.println ("** Parsing error" + ", line "
		             + err.getLineNumber () + ", uri " + err.getSystemId ());
		        System.out.println(" " + err.getMessage ());

	        }catch (SAXException e) {
			        Exception x = e.getException ();
			        ((x == null) ? e : x).printStackTrace ();

	        }catch (Throwable t) {
	        	t.printStackTrace ();
	        }

		}

	}
	public static String findNodeValue(String name_node, org.w3c.dom.Document source) {

		source.getDocumentElement();
		NodeList objCatNodes = source.getElementsByTagName(name_node);
		if(objCatNodes.getLength() == 0) return "";
		Node objNode=objCatNodes.item(0);
		NodeList objNodes = objNode.getChildNodes();		
		if(objNodes.getLength() == 0) return "";

		return org.apache.commons.lang.StringEscapeUtils.unescapeXml(replaceTags(objNodes.item(0).getNodeValue()).trim());
	}
	public static String findAttributeValue(String name_node,String name_attribute, org.w3c.dom.Document source) {

		source.getDocumentElement();
		NodeList objCatNodes = source.getElementsByTagName(name_node);
		Node objNode=objCatNodes.item(0);
		NamedNodeMap objAttributes =  objNode.getAttributes();
		Node attribute = objAttributes.getNamedItem(name_attribute);
		return org.apache.commons.lang.StringEscapeUtils.unescapeXml(replaceTags(attribute.getNodeValue()).trim());
	}
	public static String findAttributeValue(String name_attribute, Node source) {
		
		NamedNodeMap objAttributes =  source.getAttributes();
		Node attribute = objAttributes.getNamedItem(name_attribute);
		return org.apache.commons.lang.StringEscapeUtils.unescapeXml(replaceTags(attribute.getNodeValue()).trim());
	}
	public static String replaceTags(String text) {

		Matcher m = CRLF.matcher(text);
		String  newText = "";
		if (m.find()) {
			newText = m.replaceAll("");
		}
		else{
			newText = text;
		}
		
		/*
		
		m = ptag.matcher(newText);
		if (m.find()) {
			newText = m.replaceAll("\n");
		}
		*/

		return newText.trim();
		
		
	}
	public static ArrayList findNodeIDRef(String name_node,String ref_name, String catalog_name, org.w3c.dom.Document source) {

		source.getDocumentElement();
		ArrayList return_list = new ArrayList();
		NodeList objCatNodes = source.getElementsByTagName(name_node);
		
		Node objNode=objCatNodes.item(0);
		NodeList objNodes = objNode.getChildNodes();
		for(int i = 0; i < objNodes.getLength();i=i+1){
			
			if(objNodes.item(i).getNodeName().equals(ref_name)){
				NamedNodeMap objAttributes =  objNodes.item(i).getAttributes();
				Node attribute = objAttributes.getNamedItem("idref");
				//attribute.getNodeValue()
				NodeList objNodesAuthor = source.getElementsByTagName(catalog_name);
				for(int j = 0; j < objNodesAuthor.getLength();j=j+1){
					String id = objNodesAuthor.item(j).getAttributes().getNamedItem("id").getNodeValue();
					if(id.equals(attribute.getNodeValue())){
						//Node name = objNodesAuthor.item(j).getAttributes().getNamedItem("name");
						return_list.add(objNodesAuthor.item(j));
					}
					
					
				}
				
			}
			
		}
		return return_list;
	}
	public String getBaseFont_Url() {
		return BaseFont_Url;
	}
	public void setBaseFont_Url(String baseFont_Url) {
		BaseFont_Url = baseFont_Url;
	}	
	
	
		
	
	


}