/*
Copyright Ideaconsult (C) 2005-2007 
Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

package chemCast.application;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.border.BevelBorder;

import org.openscience.cdk.io.ReaderEvent;
import org.openscience.cdk.io.listener.IReaderListener;
import org.openscience.cdk.io.setting.IOSetting;

import ambit.io.RandomAccessReader;

public class StatusBar extends JPanel implements PropertyChangeListener, IReaderListener {
	public final static String Message_Error="Error";
	public final static String Message_Processing="Processing";
	public final static String Message_Progress="Progress";
	public final static String Message_Status="Status";
    /**
     * 
     */
    private static final long serialVersionUID = 5037938651046629894L;
    protected JLabel label;
    protected JProgressBar progressBar= null;
    public StatusBar() {
        super(new BorderLayout());
        label = new JLabel();
        label.setText("");
        label.setMinimumSize(new Dimension(100,24));
        label.setPreferredSize(new Dimension(600,24));
        label.setForeground(Color.blue);
        label.setOpaque(true);
        add(label,BorderLayout.CENTER);
        //label.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));

        progressBar = new JProgressBar();
        progressBar.setMinimumSize(new Dimension(100,24));
        progressBar.setPreferredSize(new Dimension(100,24));
        progressBar.setMaximum(100);
        progressBar.setMinimum(0);
        progressBar.setStringPainted(true);
        progressBar.setString("");
        progressBar.setIndeterminate(false);
        add(progressBar,BorderLayout.EAST);
        progressBar.setVisible(false);
        progressBar.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
        
    }
    public void propertyChange(PropertyChangeEvent evt) {
        try {
            if (evt.getPropertyName().equals(Message_Error)) {
                if (evt.getNewValue() instanceof Exception)
                    ((Exception) evt.getNewValue()).printStackTrace();
                label.setText(evt.getNewValue().toString());
            } else
            if (evt.getPropertyName().equals(Message_Status)) {
                label.setText(evt.getNewValue().toString());
            } else
                if (evt.getPropertyName().equals(Message_Progress)) {
                	progressBar.setIndeterminate(false);
                	Number n = (Number)evt.getNewValue();
                    progressBar.setValue(n.intValue());
                    progressBar.setString(n.toString() + "%");
                } else
                    if (evt.getPropertyName().equals(Message_Processing)) {
                    	
                    	Boolean processing = ((Boolean)evt.getNewValue()).booleanValue();
                        progressBar.setString("");
                        progressBar.setIndeterminate(processing);
                        progressBar.setVisible(processing);
                    }
        } catch (Exception x) {
            //x.printStackTrace();
        }
    }
    public void frameRead(ReaderEvent event) {
        if (event.getSource() instanceof RandomAccessReader) {
            int records = ((RandomAccessReader) event.getSource()).size();
            int record = ((RandomAccessReader) event.getSource()).getCurrentRecord();
            progressBar.setValue((100*record)/records);
            
            event =null;
        }   
    }
    public void processIOSettingQuestion(IOSetting arg0) {
        // TODO Auto-generated method stub
        
    }
}
