/*
Copyright (C) 2005-2006  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public License
as published by the Free Software Foundation; either version 2.1
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
*/

package chemCast.data;

import org.openscience.cdk.interfaces.IChemObject;

import verhaar.VerhaarScheme;
import ambit.data.IAmbitEditor;
import ambit.processors.toxtree.ToxTreeProcessor;
import chemCast.exception.FilterException;
import chemCast.ui.AbstractFilterEditor;

public class VerhaarSchemeFilter extends ObjectPropertyFilter {
	protected ToxTreeProcessor processor;
	public VerhaarSchemeFilter() throws FilterException {
		super();
		try {
		this.processor = new ToxTreeProcessor(new VerhaarScheme());
		} catch (Exception x) {
			throw new FilterException(x);
		}
	}
	@Override
	public void preprocess(IChemObject object) {
	    super.preprocess(object);
	}
	@Override
	public boolean accept(IChemObject object) {
		try {
			
			Object key = parameters.get(p_tag);
			Object property = object.getProperty(key);
			if ((property ==null) || ("".equals(property)))
				processor.process(object);
			//System.out.println(object.getProperties());
			property = object.getProperty(key);
			return acceptProperty(null, property.toString());

		} catch (Exception x) {
			x.printStackTrace();
			return false;
		}
	}
	@Override
	public IAmbitEditor getEditor() {
		return new AbstractFilterEditor("Verhaar scheme",this);
	}
}


