/* ChemCastObjectFactory.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.similarity.data;

import java.io.File;
import java.util.Collection;
import java.util.Iterator;

import javax.xml.transform.Result;
import javax.xml.transform.Source;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class ChemCastObjectFactory {
    public static Element getXMLElement(Collection<? extends IChemCastObject> collection, Document document, String elementName ) {
        Element e = document.createElement(elementName);
        Iterator<? extends IChemCastObject> i = collection.iterator();
        while (i.hasNext()) {
            e.appendChild(i.next().getXMLElement(document));
        }
        return e;
    }
    public static String toString(Collection<? extends IChemCastObject> collection) {
        StringBuffer b = new StringBuffer();
        Iterator<? extends IChemCastObject> i = collection.iterator();
        while (i.hasNext()) {
            b.append(i.next().toString());
            b.append("\t");
        }
        return b.toString();
    }

    public static IChemCastObject parseXMLDocument(Element e) throws Exception {
        String nodeName = e.getNodeName();
        if (nodeName.equals(Subset.p_group)) return new Subset(e);
        else return null;
    }
    public static void writeXmlFile(Document doc, String filename) {
        try {
            // Prepare the DOM document for writing
            Source source = new DOMSource(doc);
    
            // Prepare the output file
            File file = new File(filename);
            Result result = new StreamResult(file);
    
            // Write the DOM document to the file
            Transformer xformer = TransformerFactory.newInstance().newTransformer();
            xformer.transform(source, result);
        } catch (TransformerConfigurationException e) {
        } catch (TransformerException e) {
            
        }
        
    }

}
