/* Endpoints.java
 * Author: Nina Jeliazkova
 * Date: Sep 23, 2006 
 * Revision: 0.1 
 * 
 * Copyright (C) 2005-2006  Nina Jeliazkova
 * 
 * Contact: nina@acad.bg
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 * All we ask is that proper credit is given for our work, which includes
 * - but is not limited to - adding the above copyright notice to the beginning
 * of your source code files, and to any copyright notice that you may distribute
 * with programs based on this work.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 */

package chemCast.similarity.data;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * TODO add description
 * @author Nina Jeliazkova nina@acad.bg
 * <b>Modified</b> Sep 23, 2006
 */
public class Endpoints extends ChemCastObject implements IChemCastList {
    public static String p_endpoints="endpoints";
    protected List<Endpoint> list;
    /**
     * @param element
     * @throws Exception
     */
    public Endpoints(Element element) throws Exception {
        this();
        setXMLElement(element);
    }

    /**
     * 
     */
    public Endpoints() {
        super();
        list = new ArrayList<Endpoint>();
    }
    public Endpoint get(int i) {
        return list.get(i);
    }
    public int indexOf(Endpoint endpoint) {
    	return list.indexOf(endpoint);
    }
    public int size() {
        return list.size();
    }
    @Override
    public Element getXMLElement(Document document) {
        return ChemCastObjectFactory.getXMLElement(list, document, p_endpoints);
    }
    
    @Override
    public void setXMLElement(Element element) throws Exception {
        if (element.getNodeName().equals(p_endpoints)) {
            NodeList nodes = element.getElementsByTagName(Endpoint.p_endpoint);
            for (int i=0; i < nodes.getLength(); i++) {
                Endpoint s = new Endpoint((Element)nodes.item(i));
                add(s);
            }
        }
    }
    /* (non-Javadoc)
     * @see chemCast.similarity.data.IChemCastList#add(chemCast.similarity.data.Subset)
     */
    public void add(Endpoint endpoint) {
        firePropertyChange("add", null, endpoint);
        list.add(endpoint);
    }
    /* (non-Javadoc)
     * @see chemCast.similarity.data.IChemCastList#remove(chemCast.similarity.data.Subset)
     */
    public void remove(Endpoint endpoint) {
        firePropertyChange("remove", endpoint, null);
        list.remove(endpoint);
    }
    /* (non-Javadoc)
     * @see chemCast.similarity.data.IChemCastList#clear()
     */
    public void clear() {
        list.clear();
        super.clear();
    }
    public int compareTo(Object o) {
        // TODO Auto-generated method stub
        return 0;
    }
    public List <? extends IChemCastObject> getList() {
        return list;
    }
    @Override
    public boolean equals(Object obj) {
        if (obj instanceof Endpoints) {
            return list.equals(((Endpoints) obj).getList());
        } return super.equals(obj);
    }
    @Override
    public String toString() {
        return "Endpoints"; 
    }
    public Endpoint findByName(String name) {
    	for (int i=0; i < list.size();i++)
    		if (name.equals(list.get(i).getName())) return list.get(i);
    	return null;
    	
    }
    public void selectAll(boolean selected) {
    	for (Endpoint d : list)
    		d.setEnabled(selected);
    	
    }
}
