/*
Copyright Ideaconsult Ltd. (C) 2005-2007  

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
package chemCast.ui.actions;

import java.awt.Dimension;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;

import ambit.processors.IAmbitProcessor;
import ambit.similarity.DefaultSimilarityProcessor;
import ambit.ui.EditorPanel;
import chemCast.application.ChemCASTModule;
import chemCast.application.StatusBar;
import chemCast.similarity.data.IChemCastObject;
import chemCast.similarity.data.SimilarityModel;
import chemCast.similarity.data.SimilarityModels;
import chemCast.similarity.data.SimilaritySubsets;
import chemCast.similarity.data.Subsets;
import chemCast.ui.ChemCastListTableModel;
import chemCast.ui.ListPanel;

public class ViewSimilarityModelsAction extends ToxmatchAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 6477566188934974735L;

	public ViewSimilarityModelsAction(ChemCASTModule userData,
			JFrame mainFrame, int dataset) {
		this(userData, mainFrame, "Explore similarities" ,dataset);
		// TODO Auto-generated constructor stub
	}

	public ViewSimilarityModelsAction(ChemCASTModule userData,
			JFrame mainFrame, String name, int dataset) {
		this(userData, mainFrame, name, null, dataset);
		// TODO Auto-generated constructor stub
	}

	public ViewSimilarityModelsAction(ChemCASTModule userData,
			JFrame mainFrame, String name, Icon icon, int dataset) {
		super(userData, mainFrame, name, icon, dataset);
		// TODO Auto-generated constructor stub
	}

	@Override
	protected void processDataset(final Subsets data) throws Exception {
		getChemCastData().getPropertyChangeSupport().firePropertyChange(StatusBar.Message_Processing,null,new Boolean(false));		
		if (data instanceof SimilaritySubsets) {
			SimilarityModels m = ((SimilaritySubsets) data).getProcessors();
			if (m.getList().size()==0) return;
			final EditorPanel ed = new EditorPanel();
			ed.setPreferredSize(new Dimension(400,200));
			ed.setMinimumSize(new Dimension(200,200));
			ListPanel p = new ListPanel("Similarities",m) {
				@Override
				public void clickRow(JTable table, int row) {
					IChemCastObject sm = ((ChemCastListTableModel)table.getModel()).getList().getList().get(row);
					if (sm instanceof SimilarityModel) {
						IAmbitProcessor p = ((SimilarityModel)sm).getProcessor();
						ed.setEditor(p.getEditor());
						if (p instanceof DefaultSimilarityProcessor) {
							//SimilarityResultViewer listens on this
							((DefaultSimilarityProcessor)p).firePropertyChange("Result",
					                null,
					                ((DefaultSimilarityProcessor)p).getModelStatistics());
							//SimilarityMatrix listens on this
							data.firePropertyChange("Processor",
					                null,p);							
						}	
				                								
					}		
				}
			};
			p.setMinimumSize(new Dimension(200,200));
			p.setPreferredSize(new Dimension(400,200));
			
			JOptionPane.showMessageDialog(mainFrame,new JSplitPane(JSplitPane.VERTICAL_SPLIT,p,ed),
					data.toString(),JOptionPane.PLAIN_MESSAGE,null);
		}

	}

}


