/*
Copyright Ideaconsult Ltd. (C) 2005-2007 

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
package toxTree.test.tree.cramer;

import junit.framework.TestCase;

import org.openscience.cdk.Molecule;
import org.openscience.cdk.tools.LoggingTool;

import toxTree.core.IDecisionRule;
import toxTree.exceptions.DecisionMethodException;
import toxTree.exceptions.MolAnalyseException;
import toxTree.logging.TTLogger;
import toxTree.query.FunctionalGroups;
import toxTree.query.MolAnalyser;
import toxTree.tree.cramer.RuleAcyclicAcetalEsterOfQ30;
import toxTree.tree.cramer.RuleRingComplexSubstituents30;

/**
 * TODO add description
 * @author ThinClient
 * <b>Modified</b> 2005-8-24
 */
public class RuleAcyclicAcetalEsterOfQ30Test extends TestCase {
	public static LoggingTool logger = new LoggingTool(RuleRingComplexSubstituents30.class);
	public static void main(String[] args) {
		junit.textui.TestRunner.run(RuleAcyclicAcetalEsterOfQ30Test.class);
	}

	/*
	 * @see TestCase#setUp()
	 */
	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}

	/*
	 * @see TestCase#tearDown()
	 */
	@Override
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	/**
	 * Constructor for RuleAcyclicAcetalEsterOfQ30Test.
	 * @param arg0
	 */
	public RuleAcyclicAcetalEsterOfQ30Test(String arg0) {
		super(arg0);
		TTLogger.configureLog4j(true);		
	}
	public void testRule31() {
	    IDecisionRule rule31 = new RuleAcyclicAcetalEsterOfQ30();

	    //
	    Object[][] answer = {
	            {"COC(OC)C1=CC=CC=C1",new Boolean(true)},  //31Y
				{"c1ccc(cc1)N",new Boolean(false)},  //31N
				{"O=C(OC)c1ccccc1(NC)",new Boolean(false)},  //DMA
				{"[H]OC([H])([H])[H]",new Boolean(false)}  //DMA part of
				        
	            };
        
	    for (int i = 3; i < answer.length; i++) {
	    	Molecule mol = (Molecule)FunctionalGroups.createAtomContainer((String)answer[i][0]);
	        if (mol != null)
	            try {
	            	MolAnalyser.analyse(mol);
	                Boolean b = (Boolean) answer[i][1];
	                
	                boolean r = rule31.verifyRule(mol);
	                System.out.print((i+1) + "\t" + answer[i][0]);
	                assertEquals(b.booleanValue(),r);
	                System.out.println("\tOK");	                
	            } catch (DecisionMethodException x) {
	                x.printStackTrace();
	            } catch (MolAnalyseException x) {
	                x.printStackTrace();
	            }
	    }
	    
	}

}
