/*
Copyright Ideaconsult Ltd. (C) 2005-2007 

Contact: nina@acad.bg

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.
All we ask is that proper credit is given for our work, which includes
- but is not limited to - adding the above copyright notice to the beginning
of your source code files, and to any copyright notice that you may distribute
with programs based on this work.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/
package toxTree.tree;

import toxTree.core.IProgressStatus;

public class ProgressStatus implements IProgressStatus {
//	0 not estimated, 1 estimating; 2 estimated ; 3 : unknown ; 4 : error 
	protected short estimated;
	protected String errMessage = "";
	
	public ProgressStatus() {
		super();
		estimated = 0;
	}
	public void clear() {
		estimated = 0;
	}

	public boolean isEstimated() {
		return (estimated == 2);
	}

	public boolean isEstimating() {
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isError() {
		return estimated == 4;
	}
	public void setEstimated() {
		estimated = 2;
	}

	public void setEstimated(boolean value) {
        if (value) estimated = 2; else estimated = 0;
	}

	public void setEstimating() {
		estimated = 1;
	}

	public void setError(String message) {
		estimated = 4;
		this.errMessage = message;

	}
	public String getErrMessage() {
		return errMessage;
	}

}
